package com.mswipetech.wisepos.demo.sdk.view.bqrsale.fragment;

import android.app.Activity;
import android.app.Dialog;
import android.bluetooth.BluetoothAdapter;
import android.bluetooth.BluetoothDevice;
import android.content.ComponentName;
import android.content.Context;
import android.content.Intent;
import android.content.ServiceConnection;
import android.graphics.Bitmap;
import android.os.AsyncTask;
import android.os.Handler;
import android.os.IBinder;
import android.os.Looper;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.AdapterView;
import android.widget.BaseAdapter;
import android.widget.Button;
import android.widget.ImageView;
import android.widget.ListView;
import android.widget.TextView;
import android.widget.Toast;

import androidx.fragment.app.Fragment;

import com.bbpos.simplyprint.SimplyPrintController;
import com.google.android.material.bottomsheet.BottomSheetDialog;
import com.mswipetech.wisepad.sdk.customviews.CustomSDKButtonRegular;
import com.mswipetech.wisepad.sdk.customviews.CustomSDKTextViewRegular;
import com.mswipetech.wisepad.sdk.data.ReceiptData;
import com.mswipetech.wisepad.sdk.device.MSWisepadDeviceController;
import com.mswipetech.wisepad.sdk.device.MSWisepadDeviceControllerResponseListener;
import com.mswipetech.wisepad.sdk.device.WisePadConnection;
import com.mswipetech.wisepad.sdk.manager.services.MSPrinterListner;
import com.mswipetech.wisepad.sdk.manager.services.MSPrinterService;
import com.mswipetech.wisepad.sdk.util.ReceiptUtility;
import com.mswipetech.wisepad.sdk.util.ReceiptUtilityBlu;
import com.mswipetech.wisepad.sdk.util.ReceiptUtilityNeo;
import com.mswipetech.wisepad.sdk.util.ReceiptUtilityWPP;
import com.mswipetech.wisepos.demo.sdk.R;
import com.mswipetech.wisepos.demo.sdk.customviews.CustomTextViewMedium;
import com.mswipetech.wisepos.demo.sdk.data.AppSharedPrefrences;
import com.mswipetech.wisepos.demo.sdk.data.ApplicationData;
import com.mswipetech.wisepos.demo.sdk.util.Constants;
import com.mswipetech.wisepos.demo.sdk.util.Logs;
import com.socsi.smartposapi.printer.Printer2;

import java.util.ArrayList;
import java.util.Hashtable;

public abstract class PrinterFragment extends Fragment {
    public final static String log_tab = "PrinterFragment=>";
    private String mstrEMVProcessTaskType = "";
    private boolean isPrintRequestInQue = false;
    private Activity mActivity;
    public MSWisepadDeviceController mMSWisepadDeviceController = null;
    private EMVProcessTask mEMVProcessTask = null;
    private boolean isPrinterStarted = false;
    private ArrayList<BluetoothDevice> pairedDevicesFound = new ArrayList<>();
    private ArrayList<byte[]> receipts;
    private ArrayList<Printer2> wppreceipts;
    private boolean isUploadingSignature = false;
    private static final int REQUEST_ENABLE_BT = 0;
    private Dialog mDialogPrinter;
    private boolean isBound = false;
    private MSPrinterService mPrinterConnectionService;
    public ReceiptData mReceiptDataModel = new ReceiptData();
    boolean isCustomerCopy = false;
    public String title = "";
    private boolean isFirstTime = true;
    private final ServiceConnection mMSWisepadDeviceControllerService = new ServiceConnection() {
        public void onServiceConnected(ComponentName className, IBinder service) {
            try {
                MSWisepadDeviceController.LocalBinder localBinder = (MSWisepadDeviceController.LocalBinder) service;
                mMSWisepadDeviceController = localBinder.getService();

                if (mMSWisepadDeviceController != null) {
                    mMSWisepadDeviceController.initMswipeWisepadDeviceController(new MSWisepadDeviceObserver(),
                            true, false, false,
                            false, null);
                }
            } catch (Exception e) {

                if (ApplicationData.IS_DEBUGGING_ON)
                    Logs.v(ApplicationData.packName, "exception." + e.toString(), true, true);
            }
        }

        public void onServiceDisconnected(ComponentName className) {
            if (ApplicationData.IS_DEBUGGING_ON)
                Logs.v(ApplicationData.packName, "Wisepad servcie un-binded and wisepad is disconnected...", true, true);
            /**
             * This is called when the connection with the service has been
             * unexpectedly disconnected - process crashed.
             *
             */

            mMSWisepadDeviceController = null;

        }
    };

    private final ServiceConnection mConnection = new ServiceConnection() {

        @Override
        public void onServiceConnected(ComponentName className, IBinder service) {
            try {
                MSPrinterService.LocalBinder localBinder = (MSPrinterService.LocalBinder) service;
                mPrinterConnectionService = localBinder.getService();
                mPrinterConnectionService.setPrinterListner(new PrinterListner());

            } catch (Exception e) {
                // In this case the service has crashed before we could even do
                // anything with it
            }
        }

        @Override
        public void onServiceDisconnected(ComponentName className) {
            // This is called when the connection with the service has been
            // unexpectedly topbar_img_host_inactive - process crashed.
            mPrinterConnectionService = null;
        }
    };

    @Override
    public void onAttach(Context context) {
        super.onAttach(context);
        mActivity = getActivity();
    }

    protected void doBindService() {
        if (MSWisepadDeviceController.getDeviceType() == MSWisepadDeviceController.DeviceType.WISEPOS_NEO) {
            mActivity.bindService(new Intent(mActivity, MSWisepadDeviceController.class), mMSWisepadDeviceControllerService, Context.BIND_AUTO_CREATE);
        } else {
            mActivity.bindService(new Intent(mActivity, MSPrinterService.class), mConnection, Context.BIND_AUTO_CREATE);
        }
        isBound = true;
    }

    protected void doUnbindService() {
        if (isBound) {
            // If we have received the service, and hence registered with it,
            // then now is the time to unregister.
            // Detach our existing connection.
            if (MSWisepadDeviceController.getDeviceType() == MSWisepadDeviceController.DeviceType.WISEPOS_NEO) {
                mActivity.unbindService(mMSWisepadDeviceControllerService);
            } else {
                mActivity.unbindService(mConnection);
            }
            isBound = false;
        }
    }

    class MSWisepadDeviceObserver implements MSWisepadDeviceControllerResponseListener {

        @Override
        public void onReturnWisepadConnection(WisePadConnection wisePadConntection, BluetoothDevice bluetoothDevice) {

            if (ApplicationData.IS_DEBUGGING_ON)
                Logs.v(ApplicationData.packName, "wisePadConntection " + wisePadConntection, true, true);

            String msg = "";

            if (wisePadConntection == WisePadConnection.WisePadConnection_CONNECTED) {
                isPrinterStarted = false;

//                mIBPrintChargeSlip.setVisibility(View.VISIBLE);
//                mIBPrintChargeSlip.setEnabled(true);
                updatePrintBtnUI(true, true);

                if (ApplicationData.IS_DEBUGGING_ON)
                    Logs.v(mActivity.getPackageName(), log_tab + "onBTv2Connected", true, true);

                if (mstrEMVProcessTaskType.equalsIgnoreCase("backbutton") || mstrEMVProcessTaskType.equalsIgnoreCase("onlinesubmit")) {
                    if (mEMVProcessTask != null && mEMVProcessTask.getStatus() != AsyncTask.Status.FINISHED)
                        mEMVProcessTask.cancel(true);
                }

                new Thread() {
                    public void run() {
                        try {

                            onPrintAction();
                        } catch (Exception e) {
                            // TODO Auto-generated catch block
                            e.printStackTrace();
                        }

                    }

                    ;
                }.start();


            } else if (wisePadConntection == WisePadConnection.WisePadConnection_CONNECTING) {

            } else if (wisePadConntection == WisePadConnection.WisePadConnection_NOT_CONNECTED) {

                msg = getString(R.string.device_not_connected);
            } else if (wisePadConntection == WisePadConnection.WisePadConnection_DIS_CONNECTED) {

                msg = getString(R.string.device_disconnected);
            }

            if (msg.length() > 0) {
                showPrinterDialog(msg);
            }
        }

        @Override
        public void onRequestWisePadCheckCardProcess(CheckCardProcess checkCardProcess, ArrayList<String> dataList) {

        }

        @Override
        public void onReturnWisePadOfflineCardTransactionResults(CheckCardProcessResults checkCardResults, Hashtable<String, Object> paramHashtable) {

        }

        @Override
        public void onError(Error error, String errorMsg) {

            isPrinterStarted = false;

            String msg = "";

            if (mstrEMVProcessTaskType.equalsIgnoreCase("backbutton") ||
                    mstrEMVProcessTaskType.equalsIgnoreCase("onlinesubmit")) {

                if (mEMVProcessTask != null && mEMVProcessTask.getStatus() != AsyncTask.Status.FINISHED)
                    mEMVProcessTask.cancel(true);

            }
            if (ApplicationData.IS_DEBUGGING_ON)
                Logs.v(ApplicationData.packName, "error " + error, true, true);
            if (ApplicationData.IS_DEBUGGING_ON)
                Logs.v(ApplicationData.packName, "errorMsg " + errorMsg, true, true);
            if (msg.length() > 0) {
                showPrinterDialog(msg);
            }
        }

        @Override
        public void onRequestDisplayWispadStatusInfo(DisplayText msg) {

        }

        @Override
        public void onReturnDeviceInfo(Hashtable<String, String> paramHashtable) {

        }

        @Override
        public void onReturnFunctionKeyResult(FunctionKeyResult keyType) {

        }

        @Override
        public void onReturnWispadNetwrokSettingInfo(WispadNetwrokSetting wispadNetwrokSetting, boolean status, Hashtable<String, Object> netwrokSettingInfo) {

        }

        @Override
        public void onReturnNfcDetectCardResult(NfcDetectCardResult nfcDetectCardResult, Hashtable<String, Object> hashtable) {

        }

        @Override
        public void onReturnNfcDataExchangeResult(boolean isSuccess, Hashtable<String, String> data) {

        }

        @Override
        public void onPrintResult(PrintResult printResult) {


            if (ApplicationData.IS_DEBUGGING_ON)
                Logs.v(ApplicationData.packName, "printResult " + printResult, true, true);

            isPrinterStarted = false;

            if (mstrEMVProcessTaskType.equalsIgnoreCase("backbutton") ||
                    mstrEMVProcessTaskType.equalsIgnoreCase("onlinesubmit")) {

                if (mEMVProcessTask != null && mEMVProcessTask.getStatus() != AsyncTask.Status.FINISHED)
                    mEMVProcessTask.cancel(true);

            }

            String msg = "";

            if (printResult == PrintResult.PRINT_SUCCESS) {
                msg = getString(R.string.printer_command_success);

            } else if (printResult == PrintResult.PRINT_NO_PAPER_OR_COVER_OPENED) {
                msg = getString(R.string.no_paper);

            } else if (printResult == PrintResult.PRINT_WRONG_PRINTER_COMMAND) {
                msg = getString(R.string.printer_command_not_available);

            } else if (printResult == PrintResult.PRINT_OVERHEAT) {
                msg = getString(R.string.printer_overheat);

            } else if (printResult == PrintResult.PRINT_PRINTER_ERROR) {
                msg = getString(R.string.printer_command_not_available);

            }

            if (msg.length() > 0) {
                showPrinterDialog(msg);
            }
        }
    }

    class PrinterListner extends MSPrinterListner {


        @Override
        public void onRegisterd() {
            // TODO Auto-generated method stub
            super.onRegisterd();

        }

        @Override
        public void onUnRegisterd() {
            // TODO Auto-generated method stub
            super.onUnRegisterd();
        }


        @Override
        public void onPrinterStateChanged(PRINTER_STATE state) {
            // TODO Auto-generated method stub
            super.onPrinterStateChanged(state);
            if (ApplicationData.IS_DEBUGGING_ON)
                Logs.v(mActivity.getPackageName(), "printer state " + state, true, true);

            if (state == PRINTER_STATE.WAITINGFORCONNECTION) {

                isPrinterStarted = false;

//                mIBPrintChargeSlip.setVisibility(View.VISIBLE);
//                mIBPrintChargeSlip.setEnabled(true);
                updatePrintBtnUI(true, true);
                dismissPrinterDialog();

                mDialogPrinter = Constants.showDialog(mActivity, title,
                        getString(R.string.connecting_to_printer_if_its_taking_longer_than_usual_please_restart_the_printer_and_try_reconnecting), Constants.CUSTOM_DLG_TYPE.CUSTOM_DLG_TYPE_RETURN_DLG_INFO);

                mDialogPrinter.findViewById(R.id.customdlg_BTN_yes).setOnClickListener(new View.OnClickListener() {

                    public void onClick(View v) {
                        mDialogPrinter.dismiss();

                    }
                });

                mDialogPrinter.show();

            } else if (state == PRINTER_STATE.CONNECTED) {

                isPrinterStarted = false;

//                mIBPrintChargeSlip.setVisibility(View.VISIBLE);
//                mIBPrintChargeSlip.setEnabled(true);
                updatePrintBtnUI(true, true);

                if (ApplicationData.IS_DEBUGGING_ON)
                    Logs.v(mActivity.getPackageName(), log_tab + "onBTv2Connected", true, true);

                if (mstrEMVProcessTaskType.equalsIgnoreCase("backbutton") || mstrEMVProcessTaskType.equalsIgnoreCase("onlinesubmit")) {

                    if (mEMVProcessTask != null && mEMVProcessTask.getStatus() != AsyncTask.Status.FINISHED)
                        mEMVProcessTask.cancel(true);
                }


                new Thread() {
                    public void run() {
                        try {

                            onPrintAction();
                        } catch (Exception e) {
                            // TODO Auto-generated catch block
                            e.printStackTrace();
                        }

                    }

                    ;
                }.start();


            } else if (state == PRINTER_STATE.DISCONNECTED) {


                isPrinterStarted = false;

//                mIBPrintChargeSlip.setVisibility(View.VISIBLE);
//                mIBPrintChargeSlip.setEnabled(true);
                updatePrintBtnUI(true, true);

                if (ApplicationData.IS_DEBUGGING_ON)
                    Logs.v(mActivity.getPackageName(), log_tab + "onBTv2Disconnected  ", true, true);

                if (mstrEMVProcessTaskType.equalsIgnoreCase("backbutton") ||
                        mstrEMVProcessTaskType.equalsIgnoreCase("onlinesubmit") ||
                        mstrEMVProcessTaskType.equalsIgnoreCase("stopbluetooth")) {

                    if (mEMVProcessTask != null && mEMVProcessTask.getStatus() != AsyncTask.Status.FINISHED)
                        mEMVProcessTask.cancel(true);
                }

            } else if (state == PRINTER_STATE.PRINTING) {


            }
        }


        @Override
        public void onPrinterConnectionError(PRINTER_CONNECTION_ERROR state, ArrayList<BluetoothDevice> devices) {
            // TODO Auto-generated method stub
            super.onPrinterConnectionError(state, devices);

            isPrinterStarted = false;


            String msg = "";
//            mIBPrintChargeSlip.setVisibility(View.VISIBLE);
//            mIBPrintChargeSlip.setEnabled(true);
            updatePrintBtnUI(true, true);


            if (state == PRINTER_CONNECTION_ERROR.NO_PAIRED_DEVICE_FOUND) {

                msg = getString(R.string.no_paired_printer_found_please_pair_the_printer_from_your_phones_bluetooth_settings_and_try_again);

            } else if (state == PRINTER_CONNECTION_ERROR.MULTIPLE_PAIRED_DEVICE) {

                pairedDevicesFound = devices;

                TaskShowMultiplePairedDevices pairedtask = new TaskShowMultiplePairedDevices();
                pairedtask.execute();

//                mIBPrintChargeSlip.setEnabled(false);
                updatePrintBtnUI(true, false);
                return;

            } else if (state == PRINTER_CONNECTION_ERROR.BLUETOOTH_OFF) {

                Intent enableBtIntent = new Intent(BluetoothAdapter.ACTION_REQUEST_ENABLE);
                startActivityForResult(enableBtIntent, REQUEST_ENABLE_BT);

            } else if (state == PRINTER_CONNECTION_ERROR.UNKNOWN) {

//                msg = getString(R.string.unable_to_connect_to_the_bluetooth_printer);
                if (ApplicationData.IS_DEBUGGING_ON)
                    Logs.v(ApplicationData.packName, "Printer Connection Error Unknown => " + state, true, true);
                if (isFirstTime) {
                    mPrinterConnectionService.reconnectToDevice();
                }
                isFirstTime = false;

            } else if (state == PRINTER_CONNECTION_ERROR.CONNECTING) {
                msg = getString(R.string.connecting_to_printer_if_its_taking_longer_than_usual_please_restart_the_printer_and_try_reconnecting);
            } else if (state == PRINTER_CONNECTION_ERROR.WISEPAD_SWITCHED_OFF) {
                dismissPrinterDialog();

                mDialogPrinter = Constants.showDialog(mActivity, title,
                        getString(R.string.printer_not_connected_please_make_sure_that_the_printer_is_switched_on), Constants.CUSTOM_DLG_TYPE.CUSTOM_DLG_TYPE_RETURN_DLG_INFO,
                        getResources().getString(R.string.connect),
                        getResources().getString(R.string.close));

                Button yes = mDialogPrinter.findViewById(R.id.customdlg_BTN_yes);
                yes.setText(getResources().getString(R.string.ok));
                yes.setOnClickListener(new View.OnClickListener() {

                    public void onClick(View v) {
                        mDialogPrinter.dismiss();
                        mPrinterConnectionService.reconnectToDevice();
                    }
                });


                mDialogPrinter.show();

                return;
            } else if (state == PRINTER_CONNECTION_ERROR.PRINTING_IN_PROGRESS) {


                new Handler(Looper.getMainLooper()).post(new Runnable() {
                    @Override
                    public void run() {
                        Toast.makeText(mActivity, getString(R.string.printing_in_process), Toast.LENGTH_SHORT).show();
                    }
                });

            }

            if (ApplicationData.IS_DEBUGGING_ON)
                Logs.v(ApplicationData.packName, log_tab + "makeConnnection msg " + msg, true, true);

            if (msg.length() > 0) {
                showPrinterDialog(msg);
            }
        }


        @Override
        public void onReturnDeviceInfo(Hashtable<String, String> deviceInfoTable) {

            String msg = "";

            String productId = deviceInfoTable.get("productId");
            String firmwareVersion = deviceInfoTable.get("firmwareVersion");
            String bootloaderVersion = deviceInfoTable.get("bootloaderVersion");
            String hardwareVersion = deviceInfoTable.get("hardwareVersion");
            String isUsbConnected = deviceInfoTable.get("isUsbConnected");
            String isCharging = deviceInfoTable.get("isCharging");
            String batteryLevel = deviceInfoTable.get("batteryLevel");

            String content = "";
            content += getString(R.string.product_id) + productId + "\n";
            content += getString(R.string.firmware_version) + firmwareVersion + "\n";
            content += getString(R.string.bootloader_version) + bootloaderVersion + "\n";
            content += getString(R.string.hardware_version) + hardwareVersion + "\n";
            content += getString(R.string.usb) + isUsbConnected + "\n";
            content += getString(R.string.charge) + isCharging + "\n";
            content += getString(R.string.battery_level) + batteryLevel + "\n";

            msg = content;

            if (ApplicationData.IS_DEBUGGING_ON)
                Logs.v(mActivity.getPackageName(), log_tab + "onReturnDeviceInfo =>  msg " + msg, true, true);
        }

        @Override
        public void onReturnPrinterResult(SimplyPrintController.PrinterResult printerResult) {

            isPrinterStarted = false;

            String msg = "";

            updatePrintBtnUI(true, true);

            if (printerResult == SimplyPrintController.PrinterResult.SUCCESS) {
                msg = getString(R.string.printer_command_success);
            } else if (printerResult == SimplyPrintController.PrinterResult.NO_PAPER) {
                msg = getString(R.string.no_paper);
            } else if (printerResult == SimplyPrintController.PrinterResult.WRONG_CMD) {
                msg = getString(R.string.wrong_printer_cmd);
            } else if (printerResult == SimplyPrintController.PrinterResult.OVERHEAT) {
                msg = getString(R.string.printer_overheat);
            }

            if (ApplicationData.IS_DEBUGGING_ON)
                Logs.v(mActivity.getPackageName(), log_tab + " onReturnPrinterResult PrinterResult " + msg, true, true);


            showPrinterDialog(msg);
        }

        @Override
        public void onPrinterOperationEnd() {

            isPrinterStarted = false;

        }

		@Override
		public void onBatteryLow(SimplyPrintController.BatteryStatus batteryStatus) {

			String msg = "";

			if(batteryStatus == SimplyPrintController.BatteryStatus.LOW) {
				msg =  getString(R.string.printer_battery_low);
			} else if(batteryStatus == SimplyPrintController.BatteryStatus.CRITICALLY_LOW) {
				msg =  getString(R.string.printer_battery_critically_low);
			}

			showPrinterDialog(msg);

		}

        @Override
        public void onError(SimplyPrintController.Error errorState) {

            isPrinterStarted = false;

            String msg = "";

            if (mstrEMVProcessTaskType.equalsIgnoreCase("backbutton") ||
                    mstrEMVProcessTaskType.equalsIgnoreCase("onlinesubmit")) {

                if (mEMVProcessTask != null && mEMVProcessTask.getStatus() != AsyncTask.Status.FINISHED)
                    mEMVProcessTask.cancel(true);

            }

            if (errorState == SimplyPrintController.Error.UNKNOWN) {
                msg = getString(R.string.printer_unknown_error);
            } else if (errorState == SimplyPrintController.Error.CMD_NOT_AVAILABLE) {
                msg = getString(R.string.printer_command_not_available);
            } else if (errorState == SimplyPrintController.Error.TIMEOUT) {
                msg = getString(R.string.printer_device_no_response);
            } else if (errorState == SimplyPrintController.Error.DEVICE_BUSY) {
                msg = getString(R.string.device_busy);
            } else if (errorState == SimplyPrintController.Error.INPUT_OUT_OF_RANGE) {
                msg = getString(R.string.printer_out_of_range);
            } else if (errorState == SimplyPrintController.Error.INPUT_INVALID) {
                msg = getString(R.string.printer_input_invalid);
            } else if (errorState == SimplyPrintController.Error.CRC_ERROR) {
                msg = getString(R.string.printer_crc_error);
            } else if (errorState == SimplyPrintController.Error.FAIL_TO_START_BTV2) {
                msg = getString(R.string.printer_fail_to_start_bluetooth);
            } else if (errorState == SimplyPrintController.Error.COMM_LINK_UNINITIALIZED) {
                msg = getString(R.string.printer_comm_link_uninitialized);
            } else if (errorState == SimplyPrintController.Error.BTV2_ALREADY_STARTED) {
                msg = getString(R.string.printer_bluetooth_already_started);
            }


            if (ApplicationData.IS_DEBUGGING_ON)
                Logs.v(mActivity.getPackageName(), log_tab + "onError  the error state is " + errorState, true, true);

            try {
                showPrinterDialog(msg);
            } catch (Exception e) {
                e.printStackTrace();
            }

//            mIBPrintChargeSlip.setVisibility(View.VISIBLE);
//            mIBPrintChargeSlip.setEnabled(true);
            updatePrintBtnUI(true, true);
        }

    }

    class EMVProcessTask extends AsyncTask<Void, Integer, Void> {

        @Override
        protected void onCancelled() {

            if (ApplicationData.IS_DEBUGGING_ON)
                Logs.v(mActivity.getPackageName(), log_tab + " EmvOnlinePorcessTask onCancelled Task", true, true);


            //when the back tab is pressed
            if (mstrEMVProcessTaskType.equalsIgnoreCase("backbutton")) {

            } else if (mstrEMVProcessTaskType.equalsIgnoreCase("onlinesubmit")) {
                //dismissProgressDialog();
            } else if (mstrEMVProcessTaskType.equalsIgnoreCase("stopbluetooth")) {

                try {
                    this.notify();
                } catch (Exception ex) {
                }
                mActivity.finish();
            }
            mstrEMVProcessTaskType = "";
        }

        @Override
        protected Void doInBackground(Void... unused) {

            //calling after this statement and canceling task will no meaning if you do some update database kind of operation
            //so be wise to choose correct place to put this condition
            //you can also put this condition in for loop, if you are doing iterative task
            //you should only check this condition in doInBackground() method, otherwise there is no logical meaning

            // if the task is not cancelled by calling LoginTask.clear(true), then make the thread wait for 10 sec and then
            //quit it self
            if (ApplicationData.IS_DEBUGGING_ON)
                Logs.v(mActivity.getPackageName(), log_tab + "EmvOnlinePorcessTask start doInBackground", true, true);

            int isec = 15;

            if (mstrEMVProcessTaskType.equalsIgnoreCase("stopbluetooth"))
                isec = 6;

            int ictr = 0;
            //it will wait for 15 sec or till the task is cancelled by the mSwiper routines.
            while (!isCancelled() & ictr < isec) {
                try {
                    Thread.sleep(1000);
                } catch (Exception ex) {
                }
                ictr++;
            }
            if (ApplicationData.IS_DEBUGGING_ON)
                Logs.v(mActivity.getPackageName(), log_tab + "EmvOnlinePorcessTask  end doInBackground", true, true);
            return null;
        }


        @Override
        protected void onPostExecute(Void unused) {

            if (ApplicationData.IS_DEBUGGING_ON)
                Logs.v(mActivity.getPackageName(), log_tab + "EmvOnlinePorcessTask onPostExecute", true, true);

            //when the back tab is pressed
            if (mstrEMVProcessTaskType.equalsIgnoreCase("backbutton")) {

            } else if (mstrEMVProcessTaskType.equalsIgnoreCase("onlinesubmit")) {

            } else if (mstrEMVProcessTaskType.equalsIgnoreCase("stopbluetooth")) {
                mActivity.finish();
            }

            mstrEMVProcessTaskType = "";

        }
    }

    protected void dismissPrinterDialog() {
        try {
            if (mDialogPrinter != null)
                mDialogPrinter.dismiss();
            mDialogPrinter = null;
        } catch (Exception ex) {
            ex.printStackTrace();
        }
    }

    private class TaskShowMultiplePairedDevices extends AsyncTask<String, Void, String> {
        @Override
        protected String doInBackground(String... urls) {
            return "";
        }

        @Override
        protected void onPostExecute(String result) {

//            final Dialog dlgPairedDevices = Constants.shwoAppCustionDialog(mActivity, getResources().getString(R.string.creditsalesignatureactivity_paired_devices),
//                    getString(R.string.done), "");
            if (ApplicationData.IS_DEBUGGING_ON)
                Logs.v(ApplicationData.packName, "TaskShowMultiplePairedDevices => onPostExecute", true, true);

            final ArrayList<String> deviceNameList = new ArrayList<String>();
            for (int i = 0; i < pairedDevicesFound.size(); ++i) {
                deviceNameList.add(pairedDevicesFound.get(i).getName());
            }

            final BottomSheetDialog dlgPairedDevices = new BottomSheetDialog(mActivity, R.style.BottomSheetDialog);
            dlgPairedDevices.setContentView(R.layout.multiple_paired_authorizing_bottom_dlg_view);
            dlgPairedDevices.setCancelable(false);
            dlgPairedDevices.setCanceledOnTouchOutside(false);
            if (ApplicationData.IS_DEBUGGING_ON)
                Logs.v(ApplicationData.packName, "BottomSheet Created", true, true);

            ListView appListView = dlgPairedDevices.findViewById(R.id.application_customdlg_LST_applications);
            final ArrayList<String> arrSelectedItem = new ArrayList<String>();

            for (int ictr = 0; ictr < deviceNameList.size(); ictr++) {
                if (ictr == 0) {
                    arrSelectedItem.add("yes");
                } else {
                    arrSelectedItem.add("no");
                }
            }

            final AppViewAdapter appViewAdapter = new AppViewAdapter(mActivity, deviceNameList, arrSelectedItem);
            appListView.setAdapter(appViewAdapter);

            if (ApplicationData.IS_DEBUGGING_ON)
                Logs.v(ApplicationData.packName, "List binded", true, true);

            appListView.setOnItemClickListener(new AdapterView.OnItemClickListener() {

                @Override
                public void onItemClick(AdapterView<?> parent, View view, int position, long id) {
                    for (int ictr = 0; ictr < deviceNameList.size(); ictr++) {
                        if (ictr == position) {
                            arrSelectedItem.add(position, "yes");
                        } else {
                            arrSelectedItem.add(ictr, "no");
                        }
                    }
                    appViewAdapter.notifyDataSetChanged();
                }
            });

            CustomTextViewMedium relDone = dlgPairedDevices.findViewById(R.id.application_customdlg_BTN_done);
            relDone.setOnClickListener(new View.OnClickListener() {
                @Override
                public void onClick(View v) {
                    int scelectedDevice = 0;
                    for (int ictr = 0; ictr < arrSelectedItem.size(); ictr++) {

                        if (arrSelectedItem.get(ictr).equalsIgnoreCase("yes")) {
                            scelectedDevice = ictr;
                            if (ApplicationData.IS_DEBUGGING_ON)
                                Logs.v(ApplicationData.packName, " mswipeWisepadPairedDevices " + pairedDevicesFound.get(ictr), true, true);
                            break;
                        }
                    }
//                    mIBPrintChargeSlip.setEnabled(false);
                    updatePrintBtnUI(true, false);

                    if (mPrinterConnectionService != null)
                        mPrinterConnectionService.connectToWisePad(pairedDevicesFound.get(scelectedDevice));

                    dlgPairedDevices.dismiss();
                }
            });
            dlgPairedDevices.show();
            if (ApplicationData.IS_DEBUGGING_ON)
                Logs.v(ApplicationData.packName, "BottomSheet Shown", true, true);
        }
    }

    private class AppViewAdapter extends BaseAdapter {
        ArrayList<String> listData = null;
        ArrayList<String> arrSelectedItem = null;

        Context context;

        public AppViewAdapter(Context context, ArrayList<String> listData, ArrayList<String> aArrSelectedItem) {
            this.listData = listData;
            arrSelectedItem = aArrSelectedItem;

            this.context = context;
        }

        @Override
        public int getCount() {
            return listData.size();
        }

        @Override
        public Object getItem(int position) {
            return null;
        }

        @Override
        public long getItemId(int position) {
            return 0;
        }


        @Override
        public View getView(int position, View convertView, ViewGroup parent) {
            // TODO Auto-generated method stub
            if (convertView == null) {
                LayoutInflater inflater = LayoutInflater.from(context);
                convertView = inflater.inflate(R.layout.ms_appcustomlstitem, null);
            }

            TextView txtItem = (TextView) convertView.findViewById(R.id.appcustomlistitem_TXT_title);
            if (listData.get(position) != null)
                txtItem.setText(listData.get(position));
            ImageView img = (ImageView) convertView.findViewById(R.id.appcustomlistitem_IMG_radiobutton);
            if (arrSelectedItem.get(position).equalsIgnoreCase("no")) {
                img.setBackgroundResource(R.drawable.ms_radio_button_inactive);
            } else {
                img.setBackgroundResource(R.drawable.ms_radio_button_active);
            }

            return convertView;
        }
    }

    protected void onPrintAction() {
        if (mReceiptDataModel == null) return;
        if (MSWisepadDeviceController.getDeviceType() == MSWisepadDeviceController.DeviceType.WISEPOS_NEO) {
            printNeoReceipt();
        } else if (MSWisepadDeviceController.getDeviceType() == MSWisepadDeviceController.DeviceType.WISEPOS_PLUS) {
            printWppReceipt();
        } else {
            if (mPrinterConnectionService.bluetoothBluedevice) {
                printReceiptBlu();
            } else {
                printReceipt();
            }
        }
    }

    public void printNeoReceipt() {

        if (isBound) {

            ReceiptUtilityNeo receiptUtility = new ReceiptUtilityNeo(mActivity);

            receipts = new ArrayList<byte[]>();
            receipts.add(receiptUtility.genUPISaleReceipt(mActivity, mReceiptDataModel, false, false));


            isPrintRequestInQue = true;
            if (receipts.size() > 0) {
                mMSWisepadDeviceController.print(receipts);
            }
        } else {
            isPrintRequestInQue = true;
            doBindService();
        }
    }

    public void printWppReceipt() {

        if (ApplicationData.IS_DEBUGGING_ON)
            Logs.v(mActivity.getPackageName(), log_tab + "isBound " + isBound, true, true);

        if (isBound) {

            ReceiptUtilityWPP receiptUtility = new ReceiptUtilityWPP(mActivity);

            wppreceipts = new ArrayList<>();

            wppreceipts.add(receiptUtility.printUPIReceipt(mActivity,
                    mReceiptDataModel,
                    isCustomerCopy,
                    false));

            if (ApplicationData.IS_DEBUGGING_ON)
                Logs.v(mActivity.getPackageName(), log_tab + " isBound " + isBound, true, true);

            if (!isBound) {
                doBindService();
            }


            isPrintRequestInQue = true;

            if (wppreceipts.size() > 0) {
                mPrinterConnectionService.printReceipt(wppreceipts.get(0));
            }
        }
    }

    public void printReceiptBlu() {
        if (isBound) {

            if (mPrinterConnectionService.printerState == MSPrinterListner.PRINTER_STATE.CONNECTED) {


                ReceiptUtilityBlu receiptUtility = new ReceiptUtilityBlu(mActivity, mPrinterConnectionService.mBLuPrinter);

                receiptUtility.genUPISaleReceipt(mActivity, mReceiptDataModel, false,false);

                isPrintRequestInQue = true;

            } else {
                mPrinterConnectionService.connectToDevice();
            }

        } else {
            isPrintRequestInQue = true;
            doBindService();
        }
    }

    public void printReceipt() {

        if (isBound) {

            ReceiptUtility receiptUtility = new ReceiptUtility(mActivity);

            isPrinterStarted = true;

            if (ApplicationData.IS_DEBUGGING_ON)
                Logs.v(mActivity.getPackageName(), log_tab + " genCardSaleReceipt ", true, true);

            receipts = new ArrayList<byte[]>();
            receipts.add(receiptUtility.genUPISaleReceipt(mActivity, mReceiptDataModel, false, false));

            isPrintRequestInQue = true;

            if (receipts.size() > 0) {

                mPrinterConnectionService.printReceipt(receipts.get(0));
            }

        } else {
            isPrintRequestInQue = true;
            doBindService();
        }
    }

    private void showPrinterDialog(String msg) {
        if (!isUploadingSignature) {
            try {
                dismissPrinterDialog();

                mDialogPrinter = new Dialog(mActivity, R.style.StyleCustomDlg_white);
                mDialogPrinter.setContentView(R.layout.ms_customdlg);
                mDialogPrinter.setCanceledOnTouchOutside(false);

                mDialogPrinter.setCancelable(true);

                // to set the message
                CustomSDKTextViewRegular txtMessage = (CustomSDKTextViewRegular) mDialogPrinter.findViewById(R.id.customdlg_sdk_TXT_Info);
                txtMessage.setText(msg);

                CustomSDKButtonRegular yes = mDialogPrinter.findViewById(R.id.customdlg_sdk_BTN_yes);

                mDialogPrinter.findViewById(R.id.customdlg_sdk_RLT_no).setVisibility(View.GONE);
                yes.setText(getResources().getString(R.string.ok));
                yes.setOnClickListener(new View.OnClickListener() {

                    public void onClick(View v) {
                        mDialogPrinter.dismiss();

                    }
                });

                mDialogPrinter.getWindow().setLayout(ViewGroup.LayoutParams.MATCH_PARENT, ViewGroup.LayoutParams.WRAP_CONTENT);
                mDialogPrinter.show();

            } catch (Exception e) {
                e.printStackTrace();
            }
        }
    }

    public abstract void updatePrintBtnUI(boolean isPrintBtnVisible, boolean isPrintBtnEnable);

    public abstract Bitmap getSignatureBitmap();
}