package com.mswipetech.wisepos.demo.sdk.view.bqrsale.fragment;

import android.content.Context;
import android.graphics.Bitmap;
import android.os.Bundle;
import android.os.Handler;
import android.os.Looper;
import android.os.Message;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ImageButton;
import android.widget.TextView;

import androidx.annotation.NonNull;
import androidx.annotation.Nullable;
import androidx.appcompat.widget.AppCompatImageView;

import com.mswipetech.wisepad.sdk.MSWisepadController;
import com.mswipetech.wisepad.sdk.component.CardSaleReceiptView;
import com.mswipetech.wisepad.sdk.data.BQRResponseData;
import com.mswipetech.wisepad.sdk.data.MSDataStore;
import com.mswipetech.wisepad.sdk.data.ReceiptData;
import com.mswipetech.wisepad.sdk.listeners.MSWisepadControllerResponseListener;
import com.mswipetech.wisepos.demo.sdk.R;
import com.mswipetech.wisepos.demo.sdk.customviews.CustomProgressDialog;
import com.mswipetech.wisepos.demo.sdk.data.AppSharedPrefrences;
import com.mswipetech.wisepos.demo.sdk.data.ApplicationData;
import com.mswipetech.wisepos.demo.sdk.util.Constants;
import com.mswipetech.wisepos.demo.sdk.util.Logs;
import com.mswipetech.wisepos.demo.sdk.view.bqrsale.BQRSaleActivity;
import com.mswipetech.wisepos.demo.sdk.view.bqrsale.BQRSaleEnum;

public class QRSaleTrxnApprovalFragment extends PrinterFragment {
    public final static String log_tab = "QRSaleTrxnApprovalFragment=>";
    private Context mContext;
    private BQRSaleActivity mBQRSaleActivity = null;
    private AppCompatImageView mIBPrintChargeSlip = null;
    private ImageButton btnTxNext;
    private CardSaleReceiptView mCardSaleReceiptView = null;
    private CustomProgressDialog mProgressActivity = null;
//    private RelativeLayout creditsale_REL_redceiptdetails;

    @Override
    public void onAttach(Context context) {
        super.onAttach(context);
        mContext = context;
        mBQRSaleActivity = (BQRSaleActivity) context;
    }

    @Nullable
    @Override
    public View onCreateView(@NonNull LayoutInflater inflater, @Nullable ViewGroup container, @Nullable Bundle savedInstanceState) {
        View view = inflater.inflate(R.layout.upisale_transactionapprovalview, container, false);

        mReceiptDataModel = mBQRSaleActivity.mReceiptDataModel;
        initViews(view);

        if (AppSharedPrefrences.getAppSharedPrefrencesInstace().isPrinterSupportRequired()) {
            doBindService();
        } else {
            mIBPrintChargeSlip.setEnabled(false);
            mIBPrintChargeSlip.setVisibility(View.INVISIBLE);
        }
        return view;
    }

    public void initViews(View view) {
        if (ApplicationData.IS_DEBUGGING_ON)
            Logs.v(ApplicationData.packName, "mBQRSaleActivity.mTrnxDate " + mBQRSaleActivity.mTrnxDate, true, true);

//        mCardSaleReceiptView = view.findViewById(R.id.cardsalereceiptview_CSRV_receipt);
//        creditsale_REL_redceiptdetails = view.findViewById(R.id.creditsale_REL_redceiptdetails);

        String trxnDate = mBQRSaleActivity.mTrnxDate;
//        try {
//            if (AppSharedPrefrences.getAppSharedPrefrencesInstace().getGatewayEnvironment() == MSWisepadController.GATEWAY_ENVIRONMENT.PRODUCTION) {
//                trxnDate = Constants.getDateWithFormate(trxnDate, "MM/dd/yyyy hh:mm:ss", "dd MMM''yy',' hh:mm a");
//            } else {
        trxnDate = Constants.getDateWithFormate(trxnDate, "MM/dd/yyyy hh:mm:ss a", "dd MMM''yy',' hh:mm a");
//            }
//        } catch (Exception ex) {
//            trxnDate = mBQRSaleActivity.mTrnxDate;
//            if (ApplicationData.IS_DEBUGGING_ON)
//                Logs.v(ApplicationData.packName, "Trxn Date Error=>" + ex.getMessage(), true, true);
//            ex.printStackTrace();
//        }
//        String trxDate = Constants.getDateWithFormate(mBQRSaleActivity.mTrnxDate, "MM/dd/yyyy hh:mm:ss a", "dd MMM''yy',' hh:mm a");

        mIBPrintChargeSlip = view.findViewById(R.id.voidsaletxtdetails_BTN_print);


        TextView lblTxDateTime = (TextView) view.findViewById(R.id.upisaletxtdetails_LBL_TxDateTime);
        lblTxDateTime.setText(trxnDate);

        TextView vocherno = (TextView) view.findViewById(R.id.upisaletxtdetails_LBL_vocherno);
        vocherno.setText(mBQRSaleActivity.mVocherNo);

        TextView lblTxAmt = (TextView) view.findViewById(R.id.upisaletxtdetails_LBL_AmtRs);
        lblTxAmt.setText(Constants.getAmountWithComma(mBQRSaleActivity.mBQRAmount));

        TextView lblAuthNo = (TextView) view.findViewById(R.id.upisaletxtdetails_LBL_AuthNo);
        lblAuthNo.setText(mBQRSaleActivity.mAuthcode);

        TextView lblRRNO = (TextView) view.findViewById(R.id.upisaletxtdetails_LBL_RRNo);
        lblRRNO.setText(mBQRSaleActivity.mRRNo);

        TextView mTrnxType = (TextView) view.findViewById(R.id.upisaletxtdetails_LBL_Trnxmethod);
        mTrnxType.setText(mBQRSaleActivity.mTrnxType);

        btnTxNext = view.findViewById(R.id.voidsaletxtdetails_BTN_next);
        btnTxNext.setEnabled(true);
        btnTxNext.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                onDestroy();
                mBQRSaleActivity.finish();
            }
        });

        mIBPrintChargeSlip.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                onPrintAction();
            }
        });
    }

    @Override
    public void updatePrintBtnUI(boolean isPrintBtnVisible, boolean isPrintBtnEnable) {
        if (mIBPrintChargeSlip != null) {
            mIBPrintChargeSlip.setVisibility(isPrintBtnVisible ? View.VISIBLE : View.GONE);
            mIBPrintChargeSlip.setEnabled(isPrintBtnEnable);
        }
    }

    @Override
    public Bitmap getSignatureBitmap() {
        Bitmap signature = null;
        if (mCardSaleReceiptView != null && mCardSaleReceiptView.isSignatureDrawn()) {
            signature = mCardSaleReceiptView.getSignature();
        }
        return signature;
    }

    @Override
    public void onDestroy() {
        try {
            if (ApplicationData.IS_DEBUGGING_ON)
                Logs.v(ApplicationData.packName, log_tab + "onDestroy Called... Unbind Called", true, true);
            doUnbindService();
        } catch (Exception ex) {
            if (ApplicationData.IS_DEBUGGING_ON)
                Logs.v(ApplicationData.packName, log_tab + "onDestroy Err..." + ex.getMessage(), true, true);
            ex.printStackTrace();
        }
        super.onDestroy();
    }
}