package com.mswipetech.wisepos.demo.sdk.view.cardpaymentactivity.cardsalearrintegration;

import android.app.Dialog;
import android.content.Context;
import android.content.Intent;
import android.os.Bundle;
import android.view.View;
import android.view.Window;
import android.view.inputmethod.InputMethodManager;
import android.widget.Button;
import android.widget.EditText;
import android.widget.RelativeLayout;
import android.widget.TextView;

import androidx.fragment.app.FragmentActivity;

import com.mswipetech.wisepad.sdk.MSWisepadController;
import com.mswipetech.wisepad.sdk.data.CardSaleResponseData;
import com.mswipetech.wisepad.sdk.view.MSAARHandlerActivity;
import com.mswipetech.wisepos.demo.sdk.R;
import com.mswipetech.wisepos.demo.sdk.data.AppSharedPrefrences;
import com.mswipetech.wisepos.demo.sdk.data.ApplicationData;
import com.mswipetech.wisepos.demo.sdk.util.Constants;
import com.mswipetech.wisepos.demo.sdk.util.Logs;
import com.mswipetech.wisepos.demo.sdk.view.MenuView;

public class ARRActivityPaymentView extends FragmentActivity {
    //fields for card sale amount details screen,
    EditText mTxtUserName = null;
    EditText mTxtPassword = null;
    EditText mTxtCreditAmount = null;

    EditText mTxtPhoneNum = null;
    EditText mTxtReceipt = null;
    EditText mTxtNotes = null;
    EditText mTxtEmail = null;
    EditText mTxtExtraNote1 = null;
    EditText mTxtExtraNote2 = null;
    EditText mTxtExtraNote3 = null;
    EditText mTxtExtraNote4 = null;
    EditText mTxtExtraNote5 = null;
    EditText mTxtExtraNote6 = null;
    EditText mTxtExtraNote7 = null;
    EditText mTxtExtraNote8 = null;
    EditText mTxtExtraNote9 = null;
    EditText mTxtExtraNote10 = null;
    EditText mTxtLatitude = null;
    EditText mTxtLongitude = null;

    ApplicationData applicationData = null;

    boolean isSaleWithCash = false;
    boolean isPreAuth = false;
    boolean isEmiSale = false;

    private static final String MS_CARDSALE_ACTIVITY_INTENT_ACTION = "mswipe.wisepad.sdk.CardSaleAction";
    private static final String MS_CASHATPOS_ACTIVITY_INTENT_ACTION = "mswipe.wisepad.sdk.CashAtPosAction";
    private static final String MS_EMISALE_ACTIVITY_INTENT_ACTION = "mswipe.wisepad.sdk.EmiAction";
    private static final String MS_PREAUTH_ACTIVITY_INTENT_ACTION = "mswipe.wisepad.sdk.PreauthAction";

    public static final int MS_CARDSALE_ACTIVITY_REQUEST_CODE = 1003;
    public static final int MS_CASHATPOS_ACTIVITY_REQUEST_CODE = 1004;
    public static final int MS_EMISALE_ACTIVITY_REQUEST_CODE = 1005;
    public static final int MS_PREAUTH_ACTIVITY_REQUEST_CODE = 1006;

    /**
     * Called when the activity is first created.
     *
     * @param savedInstanceState
     */

    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        requestWindowFeature(Window.FEATURE_NO_TITLE);
        setContentView(R.layout.mswipe_arr_payment_view);

        ((RelativeLayout) findViewById(R.id.top_bar_REL_content)).setBackgroundColor(getResources().getColor(R.color.topbar_activity_background));


        applicationData = ApplicationData.getApplicationDataSharedInstance();

        initViews();
    }

    /**
     * @description All fields intilising here.
     */
    private void initViews() {
        isSaleWithCash = getIntent().getBooleanExtra("salewithcash", false);
        isPreAuth = getIntent().getBooleanExtra("preauthsale", false);
        isEmiSale = getIntent().getBooleanExtra("emisale", false);

        TextView txtHeading = ((TextView) findViewById(R.id.topbar_LBL_heading));

        if (isSaleWithCash) {
            txtHeading.setText(getResources().getString(R.string.cash_at_pos));
        } else if (isPreAuth) {
            txtHeading.setText(getResources().getString(R.string.preauth));
        } else if (isEmiSale) {
            txtHeading.setText(getResources().getString(R.string.emi));
        } else {
            txtHeading.setText(getResources().getString(R.string.card_sale));
        }

        //The screen are for the amount

        mTxtUserName = (EditText) findViewById(R.id.payment_TXT_username);
        mTxtPassword = (EditText) findViewById(R.id.payment_TXT_password);
        mTxtCreditAmount = (EditText) findViewById(R.id.payment_TXT_amount);

        mTxtPhoneNum = (EditText) findViewById(R.id.payment_TXT_mobileno);
        mTxtReceipt = (EditText) findViewById(R.id.payment_TXT_receipt);
        mTxtNotes = (EditText) findViewById(R.id.payment_TXT_notes);

        mTxtEmail = (EditText) findViewById(R.id.payment_TXT_email);

        mTxtExtraNote1 = (EditText) findViewById(R.id.payment_TXT_extra_one);
        mTxtExtraNote2 = (EditText) findViewById(R.id.payment_TXT_extra_two);
        mTxtExtraNote3 = (EditText) findViewById(R.id.payment_TXT_extra_three);
        mTxtExtraNote4 = (EditText) findViewById(R.id.payment_TXT_extra_four);
        mTxtExtraNote5 = (EditText) findViewById(R.id.payment_TXT_extra_five);
        mTxtExtraNote6 = (EditText) findViewById(R.id.payment_TXT_extra_six);
        mTxtExtraNote7 = (EditText) findViewById(R.id.payment_TXT_extra_seven);
        mTxtExtraNote8 = (EditText) findViewById(R.id.payment_TXT_extra_eight);
        mTxtExtraNote9 = (EditText) findViewById(R.id.payment_TXT_extra_nine);
        mTxtExtraNote10 = (EditText) findViewById(R.id.payment_TXT_extra_ten);

        mTxtLatitude = (EditText) findViewById(R.id.payment_TXT_latitude);
        mTxtLongitude = (EditText) findViewById(R.id.payment_TXT_longitude);

        mTxtUserName.requestFocus();

        Button btnAmtNext = (Button) findViewById(R.id.payment_BTN_amt_next);
        btnAmtNext.setBackgroundColor(getResources().getColor(R.color.topbar_activity_background));
        btnAmtNext.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View arg0) {
                // TODO Auto-generated method stub

                InputMethodManager imm = (InputMethodManager) getSystemService(Context.INPUT_METHOD_SERVICE);
                if (imm != null)
                    imm.hideSoftInputFromWindow(getCurrentFocus().getWindowToken(), InputMethodManager.HIDE_NOT_ALWAYS);

                double amount = 0;

                try {
                    if (mTxtCreditAmount.length() > 0)
                        amount = Double.parseDouble(removeChar(mTxtCreditAmount.getText().toString(), ','));
                } catch (Exception ex) {
                    amount = 0;
                }

                if (mTxtUserName.getText().toString().trim().startsWith("0")) {


                    showDialog("The userid cannot start with 0.");
                    mTxtUserName.requestFocus();
                    return;
                } else if (mTxtUserName.getText().toString().length() < 10) {
                    showDialog("enter valid userid");
                    mTxtUserName.requestFocus();
                    return;
                } else if (mTxtPassword.getText().toString().length() == 0) {
                    showDialog("enter a valid password");
                    mTxtPassword.requestFocus();
                    return;
                } else if (amount < 1) {
                    showDialog("invalid amount! minimum amount should be inr 1.00 to proceed.");
                    return;
                } else if (mTxtPhoneNum.getText().toString().trim().length() != 10) {

                    showDialog("required length of the mobile number is 10 digits.");
                    mTxtPhoneNum.requestFocus();
                    return;
                } else if (mTxtPhoneNum.getText().toString().trim().startsWith("0")) {

                    showDialog("the mobile number cannot start with 0.");
                    mTxtPhoneNum.requestFocus();
                    return;

                } else if (mTxtEmail.getText().toString().trim().length() != 0) {

                    if (emailCheck(mTxtEmail.getText().toString())) {

                    } else {
                        mTxtEmail.requestFocus();
                        return;
                    }

                }

                if (isSaleWithCash) {
                    if (amount >= 500 && (amount % 100 == 0)) {
                        processCashAtPOS();
                    } else {
                        showDialog("Amount should be greater than 500 and multiple of 100");
                        return;
                    }
                } else if (isEmiSale) {
                    processEMISale();
                } else if (isPreAuth) {
                    processPreauthSale();
                } else {
                    processCardSale();
                }

            }
        });
    }

    private void processCardSale() {

        Intent intent = new Intent(ARRActivityPaymentView.this, MSAARHandlerActivity.class);
        intent.setType(MS_CARDSALE_ACTIVITY_INTENT_ACTION);

        //Intent intent = new Intent();
        //intent.setAction(MS_CARDSALE_ACTIVITY_INTENT_ACTION);
        intent.putExtra("username", mTxtUserName.getText().toString().trim());
        intent.putExtra("password", mTxtPassword.getText().toString().trim());

        if (AppSharedPrefrences.getAppSharedPrefrencesInstace().getGatewayEnvironment() == MSWisepadController.GATEWAY_ENVIRONMENT.LABS)
            intent.putExtra("production", false);
        else
            intent.putExtra("production", true);

        double amt = Double.parseDouble(mTxtCreditAmount.getText().toString().trim());
        String totalAmt = String.format("%.2f", amt);

        if (ApplicationData.IS_DEBUGGING_ON)
            Logs.v(ApplicationData.packName, "totalAmt" + totalAmt, true, true);


        intent.putExtra("Amount", totalAmt);
        intent.putExtra("MobileNumber", mTxtPhoneNum.getText().toString().trim());
        intent.putExtra("Reciept", mTxtReceipt.getText().toString().trim());
        intent.putExtra("Notes", mTxtNotes.getText().toString().trim());
        intent.putExtra("MailId", mTxtEmail.getText().toString().trim());
        intent.putExtra("extra1", mTxtExtraNote1.getText().toString().trim());
        intent.putExtra("extra2", mTxtExtraNote2.getText().toString().trim());
        intent.putExtra("extra3", mTxtExtraNote3.getText().toString().trim());
        intent.putExtra("extra4", mTxtExtraNote4.getText().toString().trim());
        intent.putExtra("extra5", mTxtExtraNote5.getText().toString().trim());
        intent.putExtra("extra6", mTxtExtraNote6.getText().toString().trim());
        intent.putExtra("extra7", mTxtExtraNote7.getText().toString().trim());
        intent.putExtra("extra8", mTxtExtraNote8.getText().toString().trim());
        intent.putExtra("extra9", mTxtExtraNote9.getText().toString().trim());
        intent.putExtra("extra10", mTxtExtraNote10.getText().toString().trim());

        intent.putExtra("latitude", mTxtLatitude.getText().toString().trim());
        intent.putExtra("longitude", mTxtLongitude.getText().toString().trim());

        intent.putExtra("orientation", "auto");
        intent.putExtra("isPrinterSupported", AppSharedPrefrences.getAppSharedPrefrencesInstace().isPrinterSupportRequired());
        intent.putExtra("isWisepadUSBMode", AppSharedPrefrences.getAppSharedPrefrencesInstace().isWisepadUSBMode());

        startActivityForResult(intent, MS_CARDSALE_ACTIVITY_REQUEST_CODE);
    }

    private void processCashAtPOS() {

        //Intent intent = new Intent();
        //intent.setAction(MS_CASHATPOS_ACTIVITY_INTENT_ACTION);
        Intent intent = new Intent(ARRActivityPaymentView.this, MSAARHandlerActivity.class);
        intent.setType(MS_CASHATPOS_ACTIVITY_INTENT_ACTION);
        intent.putExtra("username", mTxtUserName.getText().toString().trim());
        intent.putExtra("password", mTxtPassword.getText().toString().trim());

        if (AppSharedPrefrences.getAppSharedPrefrencesInstace().getGatewayEnvironment() == MSWisepadController.GATEWAY_ENVIRONMENT.LABS)
            intent.putExtra("production", false);
        else
            intent.putExtra("production", true);

        double amt = Double.parseDouble(mTxtCreditAmount.getText().toString().trim());
        String totalAmt = String.format("%.2f", amt);

        if (ApplicationData.IS_DEBUGGING_ON)
            Logs.v(ApplicationData.packName, "totalAmt" + totalAmt, true, true);


        intent.putExtra("cashAmount", totalAmt);
        intent.putExtra("MobileNumber", mTxtPhoneNum.getText().toString().trim());
        intent.putExtra("Reciept", mTxtReceipt.getText().toString().trim());
        intent.putExtra("Notes", mTxtNotes.getText().toString().trim());
        intent.putExtra("MailId", mTxtEmail.getText().toString().trim());
        intent.putExtra("extra1", mTxtExtraNote1.getText().toString().trim());
        intent.putExtra("extra2", mTxtExtraNote2.getText().toString().trim());
        intent.putExtra("extra3", mTxtExtraNote3.getText().toString().trim());
        intent.putExtra("extra4", mTxtExtraNote4.getText().toString().trim());
        intent.putExtra("extra5", mTxtExtraNote5.getText().toString().trim());
        intent.putExtra("extra6", mTxtExtraNote6.getText().toString().trim());
        intent.putExtra("extra7", mTxtExtraNote7.getText().toString().trim());
        intent.putExtra("extra8", mTxtExtraNote8.getText().toString().trim());
        intent.putExtra("extra9", mTxtExtraNote9.getText().toString().trim());
        intent.putExtra("extra10", mTxtExtraNote10.getText().toString().trim());

        intent.putExtra("latitude", mTxtLatitude.getText().toString().trim());
        intent.putExtra("longitude", mTxtLongitude.getText().toString().trim());

        intent.putExtra("orientation", "auto");
        intent.putExtra("isPrinterSupported", AppSharedPrefrences.getAppSharedPrefrencesInstace().isPrinterSupportRequired());
        intent.putExtra("isWisepadUSBMode", AppSharedPrefrences.getAppSharedPrefrencesInstace().isWisepadUSBMode());
        startActivityForResult(intent, MS_CASHATPOS_ACTIVITY_REQUEST_CODE);
    }

    private void processEMISale() {

        Intent intent = new Intent(ARRActivityPaymentView.this, MSAARHandlerActivity.class);
        intent.setType(MS_EMISALE_ACTIVITY_INTENT_ACTION);
        intent.putExtra("username", mTxtUserName.getText().toString().trim());
        intent.putExtra("password", mTxtPassword.getText().toString().trim());

        if (AppSharedPrefrences.getAppSharedPrefrencesInstace().getGatewayEnvironment() == MSWisepadController.GATEWAY_ENVIRONMENT.LABS)
            intent.putExtra("production", false);
        else
            intent.putExtra("production", true);

        double amt = Double.parseDouble(mTxtCreditAmount.getText().toString().trim());
        String totalAmt = String.format("%.2f", amt);

        if (ApplicationData.IS_DEBUGGING_ON)
            Logs.v(ApplicationData.packName, "totalAmt" + totalAmt, true, true);

        intent.putExtra("EmiAmount", totalAmt);
        intent.putExtra("MobileNumber", mTxtPhoneNum.getText().toString().trim());
        intent.putExtra("Reciept", mTxtReceipt.getText().toString().trim());
        intent.putExtra("Notes", mTxtNotes.getText().toString().trim());
        intent.putExtra("MailId", mTxtEmail.getText().toString().trim());
        intent.putExtra("extra1", mTxtExtraNote1.getText().toString().trim());
        intent.putExtra("extra2", mTxtExtraNote2.getText().toString().trim());
        intent.putExtra("extra3", mTxtExtraNote3.getText().toString().trim());
        intent.putExtra("extra4", mTxtExtraNote4.getText().toString().trim());
        intent.putExtra("extra5", mTxtExtraNote5.getText().toString().trim());
        intent.putExtra("extra6", mTxtExtraNote6.getText().toString().trim());
        intent.putExtra("extra7", mTxtExtraNote7.getText().toString().trim());
        intent.putExtra("extra8", mTxtExtraNote8.getText().toString().trim());
        intent.putExtra("extra9", mTxtExtraNote9.getText().toString().trim());
        intent.putExtra("extra10", mTxtExtraNote10.getText().toString().trim());

        intent.putExtra("latitude", mTxtLatitude.getText().toString().trim());
        intent.putExtra("longitude", mTxtLongitude.getText().toString().trim());

        intent.putExtra("orientation", "auto");
        intent.putExtra("isPrinterSupported", AppSharedPrefrences.getAppSharedPrefrencesInstace().isPrinterSupportRequired());
        intent.putExtra("isWisepadUSBMode", AppSharedPrefrences.getAppSharedPrefrencesInstace().isWisepadUSBMode());
        startActivityForResult(intent, MS_EMISALE_ACTIVITY_REQUEST_CODE);
    }

    private void processPreauthSale() {

        //Intent intent = new Intent();
        //intent.setAction(MS_PREAUTH_ACTIVITY_INTENT_ACTION);
        Intent intent = new Intent(ARRActivityPaymentView.this, MSAARHandlerActivity.class);
        intent.setType(MS_PREAUTH_ACTIVITY_INTENT_ACTION);
        intent.putExtra("username", mTxtUserName.getText().toString().trim());
        intent.putExtra("password", mTxtPassword.getText().toString().trim());

        if (AppSharedPrefrences.getAppSharedPrefrencesInstace().getGatewayEnvironment() == MSWisepadController.GATEWAY_ENVIRONMENT.LABS)
            intent.putExtra("production", false);
        else
            intent.putExtra("production", true);

        double amt = Double.parseDouble(mTxtCreditAmount.getText().toString().trim());
        String totalAmt = String.format("%.2f", amt);

        if (ApplicationData.IS_DEBUGGING_ON)
            Logs.v(ApplicationData.packName, "totalAmt" + totalAmt, true, true);


        intent.putExtra("Amount", totalAmt);
        intent.putExtra("MobileNumber", mTxtPhoneNum.getText().toString().trim());
        intent.putExtra("Reciept", mTxtReceipt.getText().toString().trim());
        intent.putExtra("Notes", mTxtNotes.getText().toString().trim());
        intent.putExtra("MailId", mTxtEmail.getText().toString().trim());
        intent.putExtra("extra1", mTxtExtraNote1.getText().toString().trim());
        intent.putExtra("extra2", mTxtExtraNote2.getText().toString().trim());
        intent.putExtra("extra3", mTxtExtraNote3.getText().toString().trim());
        intent.putExtra("extra4", mTxtExtraNote4.getText().toString().trim());
        intent.putExtra("extra5", mTxtExtraNote5.getText().toString().trim());
        intent.putExtra("extra6", mTxtExtraNote6.getText().toString().trim());
        intent.putExtra("extra7", mTxtExtraNote7.getText().toString().trim());
        intent.putExtra("extra8", mTxtExtraNote8.getText().toString().trim());
        intent.putExtra("extra9", mTxtExtraNote9.getText().toString().trim());
        intent.putExtra("extra10", mTxtExtraNote10.getText().toString().trim());

        intent.putExtra("latitude", mTxtLatitude.getText().toString().trim());
        intent.putExtra("longitude", mTxtLongitude.getText().toString().trim());

        intent.putExtra("orientation", "auto");
        intent.putExtra("isPrinterSupported", AppSharedPrefrences.getAppSharedPrefrencesInstace().isPrinterSupportRequired());
        intent.putExtra("isWisepadUSBMode", AppSharedPrefrences.getAppSharedPrefrencesInstace().isWisepadUSBMode());
        startActivityForResult(intent, MS_PREAUTH_ACTIVITY_REQUEST_CODE);
    }


    private void showDialog(String message) {

        Constants.showActivityDialog(this, "", message);

    }


    @Override
    protected void onActivityResult(int requestCode, int resultCode, Intent data) {
        super.onActivityResult(requestCode, resultCode, data);

        if (ApplicationData.IS_DEBUGGING_ON)
            Logs.v(ApplicationData.packName, "RESULT_CODE: " + resultCode, true, true);
        if (ApplicationData.IS_DEBUGGING_ON)
            Logs.v(ApplicationData.packName, "REQUEST_CODE: " + requestCode, true, true);
        if (ApplicationData.IS_DEBUGGING_ON) {
            if (data != null)
                Logs.v(ApplicationData.packName, "data: " + data.getExtras(), true, true);
        }
        if (requestCode == MS_CARDSALE_ACTIVITY_REQUEST_CODE) {

            boolean status = data.getBooleanExtra("status", false);
            String statusMessage = data.getStringExtra("statusMessage");
            String receiptDetail = data.getStringExtra("receiptDetail");
            CardSaleResponseData cardSaleResponseData = (CardSaleResponseData) getIntent().getSerializableExtra("cardSaleResponseData");

            if (ApplicationData.IS_DEBUGGING_ON)
                Logs.v(ApplicationData.packName, "status" + status, true, true);

            if (ApplicationData.IS_DEBUGGING_ON)
                Logs.v(ApplicationData.packName, "statusMessage" + statusMessage, true, true);

            if (ApplicationData.IS_DEBUGGING_ON)
                Logs.v(ApplicationData.packName, "receiptDetail" + receiptDetail, true, true);

            if (ApplicationData.IS_DEBUGGING_ON)
                Logs.v(ApplicationData.packName, "getFirst4Digits" + cardSaleResponseData.getFirst4Digits(), true, true);

            if (ApplicationData.IS_DEBUGGING_ON)
                Logs.v(ApplicationData.packName, "getLast4Digits" + cardSaleResponseData.getLast4Digits(), true, true);

            if (resultCode == RESULT_OK) {
                showapproveDialog(Boolean.toString(status), data.getExtras().getString("AuthCode"),
                        data.getExtras().getString("RRNo"), statusMessage);
            } else {

                Constants.showActivityDialog(this, "", statusMessage);
            }
        } else if (requestCode == MS_CASHATPOS_ACTIVITY_REQUEST_CODE) {

            boolean status = data.getBooleanExtra("status", false);
            String statusMessage = data.getStringExtra("statusMessage");

            if (resultCode == RESULT_OK) {
                showapproveDialog(Boolean.toString(status), data.getExtras().getString("AuthCode"),
                        data.getExtras().getString("RRNo"), statusMessage);
            } else {

                Constants.showActivityDialog(this, "", statusMessage);

            }
        } else if (requestCode == MS_EMISALE_ACTIVITY_REQUEST_CODE) {

            boolean status = data.getBooleanExtra("status", false);
            String statusMessage = data.getStringExtra("statusMessage");

            if (ApplicationData.IS_DEBUGGING_ON)
                Logs.v(ApplicationData.packName, "status" + status, true, true);

            if (ApplicationData.IS_DEBUGGING_ON)
                Logs.v(ApplicationData.packName, "statusMessage" + statusMessage, true, true);

            if (resultCode == RESULT_OK) {
                showapproveDialog(Boolean.toString(status), data.getExtras().getString("AuthCode"),
                        data.getExtras().getString("RRNo"), statusMessage);
            } else {

                Constants.showActivityDialog(this, "", statusMessage);
            }
        } else if (requestCode == MS_PREAUTH_ACTIVITY_REQUEST_CODE) {

            boolean status = data.getBooleanExtra("status", false);
            String statusMessage = data.getStringExtra("statusMessage");

            if (resultCode == RESULT_OK) {

                showapproveDialog(Boolean.toString(status), data.getExtras().getString("AuthCode"),
                        data.getExtras().getString("RRNo"), statusMessage);
            } else {

                Constants.showActivityDialog(this, "", statusMessage);

				/*showapproveDialog(Boolean.toString(status),"",
						"",statusMessage);*/

            }
        }
    }

    /**
     * @param s original string
     * @param c specific character.
     * @return
     * @description We are removing specific character form original string.
     */
    public String removeChar(String s, char c) {

        String r = "";

        for (int i = 0; i < s.length(); i++) {
            if (s.charAt(i) != c)
                r += s.charAt(i);
        }

        return r;
    }

    public void showapproveDialog(String status, String authcode, String rrno, String reason) {

        final Dialog dialog = new Dialog(ARRActivityPaymentView.this, R.style.styleCustDlg);
        dialog.setContentView(R.layout.cardsale_status_customdlg);
        dialog.setCanceledOnTouchOutside(false);

        dialog.setCancelable(true);


        TextView txtstatusmsg = (TextView) dialog.findViewById(R.id.customdlg_Txt_status);
        txtstatusmsg.setText(status);

        TextView txtauthcode = (TextView) dialog.findViewById(R.id.customdlg_Txt_authcode);
        txtauthcode.setText(authcode);

        TextView txtrrno = (TextView) dialog.findViewById(R.id.customdlg_Txt_rrno);
        txtrrno.setText(rrno);

        TextView txtreason = (TextView) dialog.findViewById(R.id.customdlg_Txt_reason);
        txtreason.setText(reason);

        Button yes = (Button) dialog.findViewById(R.id.customdlg_BTN_yes);
        yes.setBackgroundColor(getResources().getColor(R.color.topbar_activity_background));
        yes.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                dialog.dismiss();
                finish();
                Intent intent = new Intent(ARRActivityPaymentView.this, MenuView.class);
                startActivity(intent);
            }
        });

        dialog.show();
    }

    public boolean emailCheck(String str) {

        if (!Constants.isValidEmail(str)) {

            showDialog("invalid email address");


            return false;
        } else {
            return true;
        }
    }
}