package com.mswipetech.wisepos.demo.sdk.view.cashorbanksale;

import android.app.Activity;
import android.app.Dialog;
import android.bluetooth.BluetoothAdapter;
import android.bluetooth.BluetoothDevice;
import android.content.ComponentName;
import android.content.Context;
import android.content.Intent;
import android.content.ServiceConnection;
import android.content.res.Resources;
import android.os.AsyncTask;
import android.os.Bundle;
import android.os.Handler;
import android.os.IBinder;
import android.os.Looper;
import android.view.KeyEvent;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.ViewGroup;
import android.view.Window;
import android.view.animation.Animation;
import android.view.animation.AnimationUtils;
import android.widget.AdapterView;
import android.widget.Button;
import android.widget.ImageButton;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.ListView;
import android.widget.RelativeLayout;
import android.widget.TextView;
import android.widget.Toast;

import com.bbpos.simplyprint.SimplyPrintController;
import com.mswipetech.sdk.network.MSGatewayConnectionListener;
import com.mswipetech.wisepad.sdk.MSWisepadController;
import com.mswipetech.wisepad.sdk.component.CashSaleReceiptView;
import com.mswipetech.wisepad.sdk.data.CashSaleReceiptResponseData;
import com.mswipetech.wisepad.sdk.data.CashSaleResponseData;
import com.mswipetech.wisepad.sdk.data.MSDataStore;
import com.mswipetech.wisepad.sdk.data.ReceiptData;
import com.mswipetech.wisepad.sdk.device.MSWisepadDeviceController;
import com.mswipetech.wisepad.sdk.device.MSWisepadDeviceControllerResponseListener;
import com.mswipetech.wisepad.sdk.device.WisePadConnection;
import com.mswipetech.wisepad.sdk.listeners.MSWisepadControllerResponseListener;
import com.mswipetech.wisepos.demo.sdk.Manager.services.MswipePrinterListner;
import com.mswipetech.wisepos.demo.sdk.Manager.services.MswipePrinterService;
import com.mswipetech.wisepos.demo.sdk.Manager.services.MswipePrinterService.LocalBinder;
import com.mswipetech.wisepos.demo.sdk.R;
import com.mswipetech.wisepos.demo.sdk.customviews.CustomProgressDialog;
import com.mswipetech.wisepos.demo.sdk.customviews.ListAdapter;
import com.mswipetech.wisepos.demo.sdk.data.AppSharedPrefrences;
import com.mswipetech.wisepos.demo.sdk.data.ApplicationData;
import com.mswipetech.wisepos.demo.sdk.util.Constants;
import com.mswipetech.wisepos.demo.sdk.util.Logs;
import com.mswipetech.wisepos.demo.sdk.util.ReceiptUtility;
import com.mswipetech.wisepos.demo.sdk.util.ReceiptUtilityBlu;
import com.mswipetech.wisepos.demo.sdk.util.ReceiptUtilityNeo;
import com.mswipetech.wisepos.demo.sdk.util.ReceiptUtilityWPP;
import com.socsi.smartposapi.printer.Printer2;

import java.util.ArrayList;
import java.util.Hashtable;


public class CashSaleSignatureView extends Activity {

    public final static String log_tab = "CashSaleSignatureView=>";

    CustomProgressDialog mProgressActivity = null;

    Animation alphaAnim;
    ImageView imgHostConnectionStatus;

    String title = "";
    float scale = 0;

    ApplicationData applicationData = null;
    ReceiptData mReceiptData = null;

    private MSWisepadController mMSWisepadController = null;
    private Dialog mDialogPrinter;
    RelativeLayout mRLTPrint;

    /**
     * the custom receipt widget accepts the signature from the user, and then defines the callback about the
     * actions that can be observed to take a necessary steps for processing the receipt
     */

    private CashSaleReceiptView mCashSaleReceiptView = null;

    /**
     * Stores the card sale response data, which received from the sdk
     */
    private CashSaleResponseData mCashSaleResponseData = null;

    //  connect to bluetooth printer varabiles


    int bluetoothConnectionState = 0;
    ArrayList<BluetoothDevice> pairedDevicesFound = new ArrayList<>();

    private static final int REQUEST_ENABLE_BT = 0;

    boolean wisePadDeviceConnecting = false;
    boolean isonPrinterOperationEnd = false;
    boolean isUploadingSignature = false;
    String mstrEMVProcessTaskType = "";
    EMVProcessTask mEMVProcessTask = null;

    MswipePrinterService mPrinterConnectionService;

    ArrayList<Printer2> wppreceipts;
    boolean isCustomerCopy = false;
    boolean isBound = false;
    //  end connect to bluetooth printer varabiles
    boolean isPrintRequestInQue = false;

    //for handling submit button,when print in progress.
    boolean isPrinterStarted = false;

    private long lastRequestTime = 0;
    public MSWisepadDeviceController mMSWisepadDeviceController = null;

    private final ServiceConnection mMSWisepadDeviceControllerService = new ServiceConnection() {
        public void onServiceConnected(ComponentName className, IBinder service) {
            try {
                MSWisepadDeviceController.LocalBinder localBinder = (MSWisepadDeviceController.LocalBinder) service;
                mMSWisepadDeviceController = localBinder.getService();

                if (mMSWisepadDeviceController != null) {
                    mMSWisepadDeviceController.initMswipeWisepadDeviceController(new MSWisepadDeviceObserver(),
                            true, false, false,
                            false, null);
                }
            } catch (Exception e) {
                if (ApplicationData.IS_DEBUGGING_ON)
                    Logs.e(ApplicationData.packName, e, true, true);
            }
        }

        public void onServiceDisconnected(ComponentName className) {
            if (ApplicationData.IS_DEBUGGING_ON)
                Logs.v(ApplicationData.packName, "Wisepad servcie un-binded and wisepad is disconnected...", true, true);
            mMSWisepadDeviceController = null;
        }
    };

    @Override
    public boolean onKeyDown(int keyCode, KeyEvent event) {
        if (keyCode == KeyEvent.KEYCODE_BACK) {

            return true;
        } else {
            return super.onKeyDown(keyCode, event);
        }

    }

    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);

        requestWindowFeature(Window.FEATURE_NO_TITLE);

        setContentView(R.layout.cashsale_singnature);

        applicationData = ApplicationData.getApplicationDataSharedInstance();

        Resources resources = this.getResources();
        scale = resources.getDisplayMetrics().density;

        Intent intent = getIntent();
        title = (String) intent.getStringExtra("title");

        mMSWisepadController = MSWisepadController.getSharedMSWisepadController(CashSaleSignatureView.this,
                AppSharedPrefrences.getAppSharedPrefrencesInstace().getGatewayEnvironment(),
                AppSharedPrefrences.getAppSharedPrefrencesInstace().getNetworkSource(),
                new MSGatewayConncetionObserver());

        mCashSaleResponseData = (CashSaleResponseData) getIntent().getSerializableExtra("cashSaleResponseData");

        if (title == null)
            title = "cash sale";

        mReceiptData = mCashSaleResponseData.getReceiptData();

        initViews();

        if (AppSharedPrefrences.getAppSharedPrefrencesInstace().isPrinterSupportRequired())
            doBindService();


    }

    public void initViews() {

        ((TextView) findViewById(R.id.topbar_LBL_heading)).setText(title);
        ((TextView) findViewById(R.id.topbar_LBL_heading)).setTypeface(applicationData.fontMedium);
        ((RelativeLayout) findViewById(R.id.top_bar_REL_content)).setBackgroundColor(getResources().getColor(R.color.green));
        ((LinearLayout) findViewById(R.id.topbar_LNR_topbar_menu)).setVisibility(View.GONE);
        ((TextView) findViewById(R.id.creditsale_TXT_removecard)).setVisibility(View.GONE);

        mCashSaleReceiptView = (CashSaleReceiptView) findViewById(R.id.cashsalereceiptview_CSRV_receipt);
        // set the card sale data, returned by the online card sale transaction
        mCashSaleReceiptView.setCashSaleResponseData(mCashSaleResponseData, AppSharedPrefrences.getAppSharedPrefrencesInstace().getCurrencyCode());

        mCashSaleReceiptView = (CashSaleReceiptView) findViewById(R.id.cashsalereceiptview_CSRV_receipt);

        ImageButton btnSubmit = (ImageButton) findViewById(R.id.creditsale_BTN_submitsignature);
        btnSubmit.setOnClickListener(new OnClickListener() {
            @Override
            public void onClick(View arg0) {


                if (mCashSaleReceiptView.isSignatureDrawn()) {

                    if (System.currentTimeMillis() - lastRequestTime >= ApplicationData.REQUEST_THRESHOLD_TIME) {

                        mMSWisepadController.processCashSaleReceipt(
                                AppSharedPrefrences.getAppSharedPrefrencesInstace().getReferenceId(),
                                AppSharedPrefrences.getAppSharedPrefrencesInstace().getSessionToken(),
                                mCashSaleResponseData,
                                mCashSaleReceiptView,
                                new MSWisepadControllerResponseListenerObserver());

                        mProgressActivity = new CustomProgressDialog(CashSaleSignatureView.this, title);
                        mProgressActivity.show();
                    }

                    lastRequestTime = System.currentTimeMillis();

                } else {
                    Constants.showDialog(CashSaleSignatureView.this, title, getString(R.string.cashsalesignatureactivity_please_sign_the_receipt_to_proceed));

                }
            }
        });

        ImageButton btnClear = (ImageButton) findViewById(R.id.cashsalereceiptview_BTN_clear);
        btnClear.setOnClickListener(new OnClickListener() {
            @Override
            public void onClick(View arg0) {

                mCashSaleReceiptView.clearSignature();

            }
        });


        mRLTPrint = (RelativeLayout) findViewById(R.id.creditsale_REL_print_action);
        mRLTPrint.setOnClickListener(new OnClickListener() {
            @Override
            public void onClick(View arg0) {
                onPrintAction();
            }
        });

        imgHostConnectionStatus = (ImageView) findViewById(R.id.topbar_IMG_position2);
        imgHostConnectionStatus.setVisibility(View.INVISIBLE);
        alphaAnim = AnimationUtils.loadAnimation(this, R.anim.alpha_anim);


    }

    public void printNeoReceipt() {
        if (isBound) {

            String noOfEmi = "";
            try {
                noOfEmi = mReceiptData.noOfEmi;
            } catch (Exception e) {

                noOfEmi = "";
            }

            ReceiptUtilityNeo receiptUtility = new ReceiptUtilityNeo(this);

            ArrayList<byte[]> receipts;
            if (noOfEmi.length() > 0) {

//                isPrinterStarted = true;

                if (ApplicationData.IS_DEBUGGING_ON)
                    Logs.v(getPackageName(), " genEmiSaleReceipt ", true, true);

                receipts = new ArrayList<byte[]>();
                receipts.add(receiptUtility.genEMIReceipt4(mReceiptData, null, false, ReceiptUtilityNeo.TYPE.EMI, false));


            } else {

//                isPrinterStarted = true;

                if (ApplicationData.IS_DEBUGGING_ON)
                    Logs.v(getPackageName(), " genCardSaleReceipt ", true, true);

                receipts = new ArrayList<byte[]>();
                receipts.add(receiptUtility.genReceipt4(mReceiptData, null, false, ReceiptUtilityNeo.TYPE.CARD, false));

            }

            isPrintRequestInQue = true;

            if (receipts.size() > 0) {
                mMSWisepadDeviceController.print(receipts);
            }

        } else {
            isPrintRequestInQue = true;
            doBindService();
        }
    }


    private void onPrintAction() {
        if (MSWisepadDeviceController.getDeviceType() == MSWisepadDeviceController.DeviceType.WISEPOS_NEO) {
            printNeoReceipt();
        } else if (MSWisepadDeviceController.getDeviceType() == MSWisepadDeviceController.DeviceType.WISEPOS_PLUS) {
            printWppReceipt();
        } else {
            if (mPrinterConnectionService.bluetoothBluedevice) {
                printReceiptBlu();
            } else {
                printReceipt();
            }
        }
//        if (MSWisepadDeviceController.getDeviceType() == MSWisepadDeviceController.DeviceType.WISEPOS_PLUS) {
//            printWppReceipt();
//        } else {
//            if (mPrinterConnectionService.bluetoothBluedevice) {
//
//                printReceiptBlu();
//            } else {
//                printReceipt();
//            }
//        }
    }

    /**
     * MSWisepadControllerResponseListenerObserver
     * The mswipe overridden class  observer which listens to the responses for the mswipe sdk function requests
     */
    class MSWisepadControllerResponseListenerObserver implements MSWisepadControllerResponseListener {

        /**
         * onReponseData
         * The response data notified back to the call back function
         *
         * @param aMSDataStore the generic mswipe data store, this instance is refers to Receipt information, so this
         *                     need be converted back to CardSaleReceiptResponseData to access the receipt response data
         * @return
         */
        public void onReponseData(MSDataStore aMSDataStore) {

            if (mProgressActivity != null) {
                mProgressActivity.dismiss();
                mProgressActivity = null;
            }

            CashSaleReceiptResponseData uploadSignatureResponseData = (CashSaleReceiptResponseData) aMSDataStore;
            boolean responseStatus = uploadSignatureResponseData.getResponseStatus();
            String responseMessage;

            if (responseStatus)
                responseMessage = uploadSignatureResponseData.getResponseSuccessMessage();
            else
                responseMessage = uploadSignatureResponseData.getResponseFailureReason();


            final Dialog dlg = Constants.showDialog(CashSaleSignatureView.this, title, responseMessage,
                    Constants.CUSTOM_DLG_TYPE.CUSTOM_DLG_TYPE_RETURN_DLG_INFO);
            Button btnOk = (Button) dlg.findViewById(R.id.customdlg_BTN_yes);
            btnOk.setOnClickListener(new OnClickListener() {

                @Override
                public void onClick(View arg0) {
                    // TODO Auto-generated method stub
                    dlg.dismiss();

                    doneWithCreditSale();

                }
            });
            dlg.show();

        }
    }

    /**
     * MSGatewayConncetionObserver
     * The mswipe overridden class  observer which observers the mswipe gateway network connections states
     */
    class MSGatewayConncetionObserver implements MSGatewayConnectionListener {

        @Override
        public void Connecting(String string) {
            // TODO Auto-generated method stub

            imgHostConnectionStatus.startAnimation(alphaAnim);
            imgHostConnectionStatus.setImageResource(R.drawable.topbar_img_host_inactive);

        }

        @Override
        public void Connected(String string) {
            // TODO Auto-generated method stub
            imgHostConnectionStatus.setAnimation(null);
            imgHostConnectionStatus.setImageResource(R.drawable.topbar_img_host_active);
        }

        @Override
        public void disConnect(String string) {
            // TODO Auto-generated method stub
            imgHostConnectionStatus.startAnimation(alphaAnim);
            imgHostConnectionStatus.setImageResource(R.drawable.topbar_img_host_inactive);
        }
    }

    public void doneWithCreditSale() {

        finish();

    }


    protected void onStart() {
        super.onStart();

    }

    protected void onStop() {
        doUnbindService();
        super.onStop();

    }


    private void printReceipt() {

        if (isBound) {

            isPrinterStarted = true;
            ReceiptUtility receiptUtility = new ReceiptUtility(this);
            ArrayList<byte[]> receipts = new ArrayList<byte[]>();
            receipts.add(receiptUtility.printReceipt(mReceiptData, mCashSaleReceiptView.getSignature(), false, ReceiptUtility.TYPE.CASH));

            if (receipts.size() > 0) {
                mPrinterConnectionService.printReceipt(receipts.get(0));
            }

        } else {

            isPrintRequestInQue = true;
            doBindService();
        }
    }

    private void printReceiptBlu() {

        if (isBound) {

            if (mPrinterConnectionService.printerState == MswipePrinterListner.PRINTER_STATE.CONNECTED) {
                isPrinterStarted = true;
                ReceiptUtilityBlu receiptUtility = new ReceiptUtilityBlu(this, mPrinterConnectionService.mBLuPrinter);

                receiptUtility.printReceipt(mReceiptData, mCashSaleReceiptView.getSignature(), false, ReceiptUtilityBlu.TYPE.CASH);
                mPrinterConnectionService.printReceipt(true);
            } else {
                mPrinterConnectionService.connectToDevice();
            }

        } else {

            isPrintRequestInQue = true;
            doBindService();
        }
    }


    public void printWppReceipt() {

        if (ApplicationData.IS_DEBUGGING_ON)
            Logs.v(getPackageName(), log_tab + "isBound " + isBound, true, true);

        if (isBound) {
            String noOfEmi;
            try {
                noOfEmi = mReceiptData.noOfEmi;
            } catch (Exception e) {

                noOfEmi = "";
            }
            ReceiptUtilityWPP receiptUtility = new ReceiptUtilityWPP(this);

            if (noOfEmi.length() > 0) {

                if (ApplicationData.IS_DEBUGGING_ON)
                    Logs.v(getPackageName(), log_tab + " genEmiSaleReceipt ", true, true);

                wppreceipts = new ArrayList<>();
                wppreceipts.add(receiptUtility.printReceipt(mReceiptData,
                        mCashSaleReceiptView.getSignature(),
                        false,
                        ReceiptUtilityWPP.TYPE.EMI, isCustomerCopy));

            } else {

                if (ApplicationData.IS_DEBUGGING_ON)
                    Logs.v(getPackageName(), log_tab + " genCardSaleReceipt ", true, true);

                wppreceipts = new ArrayList<>();
                wppreceipts.add(receiptUtility.printReceipt(mReceiptData,
                        mCashSaleReceiptView.getSignature(),
                        false,
                        ReceiptUtilityWPP.TYPE.CARD, isCustomerCopy));
            }

            if (ApplicationData.IS_DEBUGGING_ON)
                Logs.v(getPackageName(), log_tab + " isBound " + isBound, true, true);

            if (!isBound) {
                doBindService();
            }


            isPrintRequestInQue = true;

            if (wppreceipts.size() > 0) {
                mPrinterConnectionService.printReceipt(wppreceipts.get(0));
            }
        } else {
            isPrintRequestInQue = true;
            doBindService();
        }
    }


    void doBindService() {
        if (MSWisepadDeviceController.getDeviceType() == MSWisepadDeviceController.DeviceType.WISEPOS_NEO) {
            bindService(new Intent(this, MSWisepadDeviceController.class), mMSWisepadDeviceControllerService, Context.BIND_AUTO_CREATE);
        } else {
            bindService(new Intent(this, MswipePrinterService.class), mConnection, Context.BIND_AUTO_CREATE);
        }
//		bindService(new Intent(this, MswipePrinterService.class), mConnection, Context.BIND_AUTO_CREATE);
        isBound = true;

    }


    void doUnbindService() {

        if (isBound) {
            if (MSWisepadDeviceController.getDeviceType() == MSWisepadDeviceController.DeviceType.WISEPOS_NEO) {
                unbindService(mMSWisepadDeviceControllerService);
            } else {
                unbindService(mConnection);
            }
//			unbindService(mConnection);
            isBound = false;
        }
    }

    private final ServiceConnection mConnection = new ServiceConnection() {
        public void onServiceConnected(ComponentName className, IBinder service) {
            try {
                LocalBinder localBinder = (LocalBinder) service;
                mPrinterConnectionService = localBinder.getService();
                mPrinterConnectionService.setPrinterListner(new PrinterListner());
            } catch (Exception e) {
                // In this case the service has crashed before we could even do
                // anything with it
            }
        }

        public void onServiceDisconnected(ComponentName className) {
            // This is called when the connection with the service has been
            // unexpectedly topbar_img_host_inactive - process crashed.
            mPrinterConnectionService = null;
        }
    };


    class PrinterListner extends MswipePrinterListner {


        @Override
        public void onRegisterd() {
            super.onRegisterd();

        }

        @Override
        public void onUnRegisterd() {
            super.onUnRegisterd();
        }


        @Override
        public void onPrinterStateChanged(PRINTER_STATE state) {
            // TODO Auto-generated method stub
            super.onPrinterStateChanged(state);

            if (ApplicationData.IS_DEBUGGING_ON)
                Logs.v(getPackageName(), "printer state " + state, true, true);

            if (state == PRINTER_STATE.WAITINGFORCONNECTION) {

                isPrinterStarted = false;

                mRLTPrint.setVisibility(View.VISIBLE);

                final Dialog dialog = Constants.showDialog(CashSaleSignatureView.this, title,
                        getString(R.string.connecting_to_printer_if_its_taking_longer_than_usual_please_restart_the_printer_and_try_reconnecting), Constants.CUSTOM_DLG_TYPE.CUSTOM_DLG_TYPE_RETURN_DLG_INFO);

                Button yes = (Button) dialog.findViewById(R.id.customdlg_BTN_yes);
                yes.setOnClickListener(new OnClickListener() {

                    public void onClick(View v) {
                        dialog.dismiss();

                    }
                });

                dialog.show();

            } else if (state == PRINTER_STATE.CONNECTED) {

                isPrinterStarted = false;

                mRLTPrint.setVisibility(View.VISIBLE);

                if (ApplicationData.IS_DEBUGGING_ON)
                    Logs.v(getPackageName(), log_tab + "onBTv2Connected", true, true);

                if (mstrEMVProcessTaskType.equalsIgnoreCase("backbutton") || mstrEMVProcessTaskType.equalsIgnoreCase("onlinesubmit")) {

                    if (mEMVProcessTask != null && mEMVProcessTask.getStatus() != AsyncTask.Status.FINISHED)
                        mEMVProcessTask.cancel(true);
                }

                new Thread() {
                    public void run() {
                        try {
                            sleep(1000);

                            onPrintAction();

                        } catch (InterruptedException e) {
                            // TODO Auto-generated catch block
                            e.printStackTrace();
                        }

                    }

                }.start();


            } else if (state == PRINTER_STATE.DISCONNECTED) {

                isPrinterStarted = false;

                mRLTPrint.setVisibility(View.VISIBLE);

                wisePadDeviceConnecting = false;
                bluetoothConnectionState = 0;

                if (ApplicationData.IS_DEBUGGING_ON)
                    Logs.v(getPackageName(), log_tab + "onBTv2Disconnected  ", true, true);

                if (mstrEMVProcessTaskType.equalsIgnoreCase("backbutton") ||
                        mstrEMVProcessTaskType.equalsIgnoreCase("onlinesubmit") ||
                        mstrEMVProcessTaskType.equalsIgnoreCase("stopbluetooth")) {

                    if (mEMVProcessTask != null && mEMVProcessTask.getStatus() != AsyncTask.Status.FINISHED)
                        mEMVProcessTask.cancel(true);
                }

            } else if (state == PRINTER_STATE.PRINTING) {


            }
        }


        @Override
        public void onPrinterConnectionError(PRINTER_CONNECTION_ERROR state, ArrayList<BluetoothDevice> devices) {
            super.onPrinterConnectionError(state, devices);

            isPrinterStarted = false;

            String msg = "";
            mRLTPrint.setVisibility(View.VISIBLE);

            wisePadDeviceConnecting = false;

            if (state == PRINTER_CONNECTION_ERROR.NO_PAIRED_DEVICE_FOUND) {

                msg = getString(R.string.no_paired_printer_found_please_pair_the_printer_from_your_phones_bluetooth_settings_and_try_again);

            } else if (state == PRINTER_CONNECTION_ERROR.MULTIPLE_PAIRED_DEVICE) {

                pairedDevicesFound = devices;

                TaskShowMultiplePairedDevices pairedtask = new TaskShowMultiplePairedDevices();
                pairedtask.execute();

                mRLTPrint.setEnabled(false);
                return;
            } else if (state == PRINTER_CONNECTION_ERROR.BLUETOOTH_OFF) {

                Intent enableBtIntent = new Intent(BluetoothAdapter.ACTION_REQUEST_ENABLE);
                startActivityForResult(enableBtIntent, REQUEST_ENABLE_BT);

            } else if (state == PRINTER_CONNECTION_ERROR.UNKNOWN) {

                msg = getString(R.string.unable_to_connect_to_the_bluetooth_printer);

            } else if (state == PRINTER_CONNECTION_ERROR.CONNECTING) {
                msg = getString(R.string.connecting_to_printer_if_its_taking_longer_than_usual_please_restart_the_printer_and_try_reconnecting);
            } else if (state == PRINTER_CONNECTION_ERROR.WISEPAD_SWITCHED_OFF) {
                final Dialog dialog = Constants.showDialog(CashSaleSignatureView.this, title,
                        getString(R.string.printer_not_connected_please_make_sure_that_the_printer_is_switched_on), Constants.CUSTOM_DLG_TYPE.CUSTOM_DLG_TYPE_RETURN_DLG_INFO,
                        getResources().getString(R.string.connect),
                        getResources().getString(R.string.close));

                Button yes = (Button) dialog.findViewById(R.id.customdlg_BTN_yes);
                ((Button) dialog.findViewById(R.id.customdlg_BTN_yes)).setText(getResources().getString(R.string.ok));
                yes.setOnClickListener(new OnClickListener() {

                    public void onClick(View v) {
                        dialog.dismiss();
                        mPrinterConnectionService.reconnectToDevice();
                    }
                });


                dialog.show();

                return;
            } else if (state == PRINTER_CONNECTION_ERROR.PRINTING_IN_PROGRESS) {


                new Handler(Looper.getMainLooper()).post(new Runnable() {
                    @Override
                    public void run() {
                        Toast.makeText(CashSaleSignatureView.this, getString(R.string.printing_in_process), Toast.LENGTH_SHORT).show();
                    }
                });

            }

            if (ApplicationData.IS_DEBUGGING_ON)
                Logs.v(ApplicationData.packName, log_tab + "makeConnnection msg " + msg, true, true);

            if (msg.length() > 0) {
                showPrinterDialog(msg);
            }
        }


        @Override
        public void onReturnDeviceInfo(Hashtable<String, String> deviceInfoTable) {

            String msg = "";

            String productId = deviceInfoTable.get("productId");
            String firmwareVersion = deviceInfoTable.get("firmwareVersion");
            String bootloaderVersion = deviceInfoTable.get("bootloaderVersion");
            String hardwareVersion = deviceInfoTable.get("hardwareVersion");
            String isUsbConnected = deviceInfoTable.get("isUsbConnected");
            String isCharging = deviceInfoTable.get("isCharging");
            String batteryLevel = deviceInfoTable.get("batteryLevel");

            String content = "";
            content += getString(R.string.product_id) + productId + "\n";
            content += getString(R.string.firmware_version) + firmwareVersion + "\n";
            content += getString(R.string.bootloader_version) + bootloaderVersion + "\n";
            content += getString(R.string.hardware_version) + hardwareVersion + "\n";
            content += getString(R.string.usb) + isUsbConnected + "\n";
            content += getString(R.string.charge) + isCharging + "\n";
            content += getString(R.string.battery_level) + batteryLevel + "\n";

            msg = content;

            if (applicationData.IS_DEBUGGING_ON)
                Logs.v(getPackageName(), log_tab + "onReturnDeviceInfo =>  msg " + msg, true, true);
        }

        @Override
        public void onReturnPrinterResult(SimplyPrintController.PrinterResult printerResult) {

            isPrinterStarted = false;

            String msg = "";

            mRLTPrint.setVisibility(View.VISIBLE);

            if (printerResult == SimplyPrintController.PrinterResult.SUCCESS) {
                msg = getString(R.string.printer_command_success);
            } else if (printerResult == SimplyPrintController.PrinterResult.NO_PAPER) {
                msg = getString(R.string.no_paper);
            } else if (printerResult == SimplyPrintController.PrinterResult.WRONG_CMD) {
                msg = getString(R.string.wrong_printer_cmd);
            } else if (printerResult == SimplyPrintController.PrinterResult.OVERHEAT) {
                msg = getString(R.string.printer_overheat);
            }

            if (ApplicationData.IS_DEBUGGING_ON)
                Logs.v(getPackageName(), log_tab + " onReturnPrinterResult PrinterResult " + msg, true, true);

            showPrinterDialog(msg);

        }

        @Override
        public void onPrinterOperationEnd() {

            isPrinterStarted = false;

            isonPrinterOperationEnd = true;

        }

        @Override
        public void onBatteryLow(SimplyPrintController.BatteryStatus batteryStatus) {

            String msg = "";

            if (batteryStatus == SimplyPrintController.BatteryStatus.LOW) {
                msg = getString(R.string.printer_battery_low);
            } else if (batteryStatus == SimplyPrintController.BatteryStatus.CRITICALLY_LOW) {
                msg = getString(R.string.printer_battery_critically_low);
            }

            try {

                Constants.showDialog(CashSaleSignatureView.this, title, msg);

            } catch (Exception e) {
                e.printStackTrace();
            }

        }

        @Override
        public void onError(SimplyPrintController.Error errorState) {

            isPrinterStarted = false;

            String msg = "";

            if (mstrEMVProcessTaskType.equalsIgnoreCase("backbutton") ||
                    mstrEMVProcessTaskType.equalsIgnoreCase("onlinesubmit")) {

                if (mEMVProcessTask != null && mEMVProcessTask.getStatus() != AsyncTask.Status.FINISHED)
                    mEMVProcessTask.cancel(true);

            }

            if (errorState == SimplyPrintController.Error.UNKNOWN) {
                msg = getString(R.string.printer_unknown_error);
            } else if (errorState == SimplyPrintController.Error.CMD_NOT_AVAILABLE) {
                msg = getString(R.string.printer_command_not_available);
            } else if (errorState == SimplyPrintController.Error.TIMEOUT) {
                msg = getString(R.string.printer_device_no_response);
            } else if (errorState == SimplyPrintController.Error.DEVICE_BUSY) {
                msg = getString(R.string.printer_device_busy);
            } else if (errorState == SimplyPrintController.Error.INPUT_OUT_OF_RANGE) {
                msg = getString(R.string.printer_out_of_range);
            } else if (errorState == SimplyPrintController.Error.INPUT_INVALID) {
                msg = getString(R.string.printer_input_invalid);
            } else if (errorState == SimplyPrintController.Error.CRC_ERROR) {
                msg = getString(R.string.printer_crc_error);
            } else if (errorState == SimplyPrintController.Error.FAIL_TO_START_BTV2) {
                msg = getString(R.string.printer_fail_to_start_bluetooth);
            } else if (errorState == SimplyPrintController.Error.COMM_LINK_UNINITIALIZED) {
                msg = getString(R.string.printer_comm_link_uninitialized);
            } else if (errorState == SimplyPrintController.Error.BTV2_ALREADY_STARTED) {
                msg = getString(R.string.printer_bluetooth_already_started);
            }


            if (ApplicationData.IS_DEBUGGING_ON)
                Logs.v(getPackageName(), log_tab + "onError  the error state is " + errorState, true, true);

            showPrinterDialog(msg);

            mRLTPrint.setVisibility(View.VISIBLE);

        }

    }

    private void dismissPrinterDialog() {

        try {
            if (mDialogPrinter != null)
                mDialogPrinter.dismiss();
            mDialogPrinter = null;
        } catch (Exception ex) {
        }
    }

    private void showPrinterDialog(String msg) {
        if (!isUploadingSignature) {
            try {

                dismissPrinterDialog();
                mDialogPrinter = new Dialog(CashSaleSignatureView.this);
                mDialogPrinter.setContentView(R.layout.customdlg);
                mDialogPrinter.setCanceledOnTouchOutside(false);

                mDialogPrinter.setCancelable(true);

                ApplicationData applicationData = ApplicationData.getApplicationDataSharedInstance();

                // set the title
                TextView txttitle = (TextView) mDialogPrinter.findViewById(R.id.customdlg_TXT_title);
                txttitle.setText(title);

                // to set the message
                TextView txtMessage = (TextView) mDialogPrinter.findViewById(R.id.customdlg_TXT_Info);
                txtMessage.setText(msg);

                Button yes = (Button) mDialogPrinter.findViewById(R.id.customdlg_BTN_yes);
				/*yes.setText("ok");
				yes.setTypeface(applicationData.font);*/

                Button no = (Button) mDialogPrinter.findViewById(R.id.customdlg_BTN_no);

                ((Button) mDialogPrinter.findViewById(R.id.customdlg_BTN_yes)).setText(getResources().getString(R.string.ok));
                ((Button) mDialogPrinter.findViewById(R.id.customdlg_BTN_no)).setText(getResources().getString(R.string.cancel));

				/*no.setText("clear");
				no.setTypeface(applicationData.font);*/
                no.setVisibility(View.GONE);
                yes.setOnClickListener(new OnClickListener() {

                    public void onClick(View v) {
                        mDialogPrinter.dismiss();

                    }
                });

                mDialogPrinter.getWindow().setLayout(ViewGroup.LayoutParams.MATCH_PARENT, ViewGroup.LayoutParams.WRAP_CONTENT);
                mDialogPrinter.show();

            } catch (Exception e) {
                e.printStackTrace();
            }
        }
    }


    class EMVProcessTask extends AsyncTask<Void, Integer, Void> {

        @Override
        protected void onCancelled() {

            if (applicationData.IS_DEBUGGING_ON)
                Logs.v(getPackageName(), log_tab + " EmvOnlinePorcessTask onCancelled Task", true, true);

            //when the back tab is pressed
            if (mstrEMVProcessTaskType.equalsIgnoreCase("backbutton")) {

            } else if (mstrEMVProcessTaskType.equalsIgnoreCase("onlinesubmit")) {
                //dismissProgressDialog();
            } else if (mstrEMVProcessTaskType.equalsIgnoreCase("stopbluetooth")) {

                try {
                    this.notify();
                } catch (Exception ex) {
                }
                finish();
            }

            mstrEMVProcessTaskType = "";

        }

        @Override
        protected Void doInBackground(Void... unused) {

            //calling after this statement and canceling task will no meaning if you do some update database kind of operation
            //so be wise to choose correct place to put this condition
            //you can also put this condition in for loop, if you are doing iterative task
            //you should only check this condition in doInBackground() method, otherwise there is no logical meaning

            // if the task is not cancelled by calling LoginTask.clear(true), then make the thread wait for 10 sec and then
            //quit it self
            if (applicationData.IS_DEBUGGING_ON)
                Logs.v(getPackageName(), log_tab + "EmvOnlinePorcessTask start doInBackground", true, true);

            int isec = 15;

            if (mstrEMVProcessTaskType.equalsIgnoreCase("stopbluetooth"))
                isec = 6;

            int ictr = 0;
            //it will wait for 15 sec or till the task is cancelled by the mSwiper routines.
            while (!isCancelled() & ictr < isec) {
                try {
                    Thread.sleep(500);
                } catch (Exception ex) {
                }
                ictr++;
            }
            if (applicationData.IS_DEBUGGING_ON)
                Logs.v(getPackageName(), log_tab + "EmvOnlinePorcessTask  end doInBackground", true, true);
            return null;
        }


        @Override
        protected void onPostExecute(Void unused) {

            if (applicationData.IS_DEBUGGING_ON)
                Logs.v(getPackageName(), log_tab + "EmvOnlinePorcessTask onPostExecute", true, true);

            //when the back tab is pressed
            if (mstrEMVProcessTaskType.equalsIgnoreCase("backbutton")) {

            } else if (mstrEMVProcessTaskType.equalsIgnoreCase("onlinesubmit")) {

            } else if (mstrEMVProcessTaskType.equalsIgnoreCase("stopbluetooth")) {
                finish();
            }

            mstrEMVProcessTaskType = "";

        }
    }


    private class TaskShowMultiplePairedDevices extends AsyncTask<String, Void, String> {
        @Override
        protected String doInBackground(String... urls) {
            return "";
        }

        @Override
        protected void onPostExecute(String result) {

            final Dialog dlgPairedDevices = Constants.showAppCustomDialog(CashSaleSignatureView.this, getResources().getString(R.string.mswisepadview_select_wisepad));
            dlgPairedDevices.setCancelable(true);

            final ArrayList<String> deviceNameList = new ArrayList<String>();

            for (int i = 0; i < pairedDevicesFound.size(); ++i) {
                deviceNameList.add(pairedDevicesFound.get(i).getName());
            }


            final ListView appListView = (ListView) dlgPairedDevices.findViewById(R.id.customapplicationdlg_LST_applications);

            appListView.setAdapter(new ListAdapter(CashSaleSignatureView.this, deviceNameList));
            appListView.setOnItemClickListener(new AdapterView.OnItemClickListener() {

                @Override
                public void onItemClick(AdapterView<?> parent, View view, int position, long id) {

                    mRLTPrint.setEnabled(false);

                    if (mPrinterConnectionService != null)
                        mPrinterConnectionService.connectToWisePad(pairedDevicesFound.get(position));

                    dlgPairedDevices.dismiss();
                }

            });

            dlgPairedDevices.findViewById(R.id.customapplicationdlg_BTN_cancel).setOnClickListener(new OnClickListener() {

                @Override
                public void onClick(View v) {

                    dlgPairedDevices.dismiss();
                }
            });

            dlgPairedDevices.show();


        }
    }

    class MSWisepadDeviceObserver implements MSWisepadDeviceControllerResponseListener {

        @Override
        public void onReturnWisepadConnection(WisePadConnection wisePadConntection, BluetoothDevice bluetoothDevice) {

            if (ApplicationData.IS_DEBUGGING_ON)
                Logs.v(ApplicationData.packName, "wisePadConntection " + wisePadConntection, true, true);

            String msg = "";
            CashSaleSignatureView activity = CashSaleSignatureView.this;

            if (wisePadConntection == WisePadConnection.WisePadConnection_CONNECTED) {
//                isPrinterStarted = false;

                mRLTPrint.setVisibility(View.VISIBLE);
                mRLTPrint.setEnabled(true);

                if (ApplicationData.IS_DEBUGGING_ON)
                    Logs.v(activity.getPackageName(), "onBTv2Connected", true, true);

                if (activity.mstrEMVProcessTaskType.equalsIgnoreCase("backbutton") || activity.mstrEMVProcessTaskType.equalsIgnoreCase("onlinesubmit")) {

                    if (activity.mEMVProcessTask != null && activity.mEMVProcessTask.getStatus() != AsyncTask.Status.FINISHED)
                        activity.mEMVProcessTask.cancel(true);
                }


//                new Thread() {
//                    public void run() {
                try {
                    onPrintAction();
                    isPrintRequestInQue = false;
                } catch (Exception e) {
                    e.printStackTrace();
                }
//                    }
//                }.start();


            } else if (wisePadConntection == WisePadConnection.WisePadConnection_CONNECTING) {

            } else if (wisePadConntection == WisePadConnection.WisePadConnection_NOT_CONNECTED) {

                msg = getString(R.string.device_not_connected);
            } else if (wisePadConntection == WisePadConnection.WisePadConnection_DIS_CONNECTED) {

                msg = getString(R.string.device_disconnected);
            }

            if (msg.length() > 0) {
                showPrinterDialog(msg);
            }
        }

        @Override
        public void onRequestWisePadCheckCardProcess(CheckCardProcess checkCardProcess, ArrayList<String> dataList) {

        }

        @Override
        public void onReturnWisePadOfflineCardTransactionResults(CheckCardProcessResults checkCardResults, Hashtable<String, Object> paramHashtable) {

        }

        @Override
        public void onError(Error error, String errorMsg) {

//            isPrinterStarted = false;

            CashSaleSignatureView activity = CashSaleSignatureView.this;
            if (activity.mstrEMVProcessTaskType.equalsIgnoreCase("backbutton") ||
                    activity.mstrEMVProcessTaskType.equalsIgnoreCase("onlinesubmit")) {

                if (activity.mEMVProcessTask != null && activity.mEMVProcessTask.getStatus() != AsyncTask.Status.FINISHED)
                    activity.mEMVProcessTask.cancel(true);

            }
            if (ApplicationData.IS_DEBUGGING_ON)
                Logs.v(ApplicationData.packName, "error " + error, true, true);
            if (errorMsg.length() > 0) {
                showPrinterDialog(errorMsg);
            }
        }

        @Override
        public void onRequestDisplayWispadStatusInfo(DisplayText msg) {

        }

        @Override
        public void onReturnDeviceInfo(Hashtable<String, String> paramHashtable) {

        }

        @Override
        public void onReturnFunctionKeyResult(FunctionKeyResult keyType) {

        }

        @Override
        public void onReturnWispadNetwrokSettingInfo(WispadNetwrokSetting wispadNetwrokSetting, boolean status, Hashtable<String, Object> netwrokSettingInfo) {

        }

        @Override
        public void onReturnNfcDetectCardResult(NfcDetectCardResult nfcDetectCardResult, Hashtable<String, Object> hashtable) {

        }

        @Override
        public void onReturnNfcDataExchangeResult(boolean isSuccess, Hashtable<String, String> data) {

        }

        @Override
        public void onPrintResult(PrintResult printResult) {


            if (ApplicationData.IS_DEBUGGING_ON)
                Logs.v(ApplicationData.packName, "printResult " + printResult, true, true);

//            isPrinterStarted = false;

            CashSaleSignatureView activity = CashSaleSignatureView.this;
            if (activity.mstrEMVProcessTaskType.equalsIgnoreCase("backbutton") ||
                    activity.mstrEMVProcessTaskType.equalsIgnoreCase("onlinesubmit")) {

                if (activity.mEMVProcessTask != null && activity.mEMVProcessTask.getStatus() != AsyncTask.Status.FINISHED)
                    activity.mEMVProcessTask.cancel(true);

            }

            String msg = "";

            if (printResult == PrintResult.PRINT_SUCCESS) {
                msg = getString(R.string.printer_command_success);

            } else if (printResult == PrintResult.PRINT_NO_PAPER_OR_COVER_OPENED) {
                msg = getString(R.string.no_paper);

            } else if (printResult == PrintResult.PRINT_WRONG_PRINTER_COMMAND) {
                msg = getString(R.string.printer_command_not_available);

            } else if (printResult == PrintResult.PRINT_OVERHEAT) {
                msg = getString(R.string.printer_overheat);

            } else if (printResult == PrintResult.PRINT_PRINTER_ERROR) {
                msg = getString(R.string.printer_command_not_available);

            }

            if (msg.length() > 0) {
                showPrinterDialog(msg);
            }
        }
    }
}
