package com.mswipetech.wisepos.demo.sdk.view.settings;

import android.os.Bundle;
import android.view.Window;
import android.widget.CheckBox;
import android.widget.RadioGroup;
import android.widget.TextView;

import com.mswipetech.wisepad.sdk.MSWisepadController;
import com.mswipetech.wisepos.demo.sdk.R;
import com.mswipetech.wisepos.demo.sdk.data.AppSharedPrefrences;
import com.mswipetech.wisepos.demo.sdk.data.ApplicationData;
import com.mswipetech.wisepos.demo.sdk.view.BaseTitleActivity;

public class DeviceSettings extends BaseTitleActivity {

	RadioGroup settings_RG_gatewayenv = null;
	CheckBox settings_CHK_usb_mode = null;
	CheckBox settings_CHK_printer_support = null;
    ApplicationData applicationData = null;

    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);

        applicationData = (ApplicationData) getApplicationContext();
		requestWindowFeature(Window.FEATURE_NO_TITLE);

        setContentView(R.layout.device_settings);
        initViews();
    }

    private void initViews() {
    	
    	 TextView txtHeading = findViewById(R.id.topbar_LBL_heading);
         txtHeading.setText("Device Settings");
         txtHeading.setTypeface(applicationData.font);

		settings_RG_gatewayenv = findViewById(R.id.settings_RG_gatewayenv);

		settings_CHK_usb_mode = findViewById(R.id.settings_CHK_usb_mode);
		settings_CHK_usb_mode.setTypeface(applicationData.font);

		settings_CHK_printer_support = findViewById(R.id.settings_CHK_printer_support);
		settings_CHK_printer_support.setTypeface(applicationData.font);


		if (AppSharedPrefrences.getAppSharedPrefrencesInstace().getGatewayEnvironment() == MSWisepadController.GATEWAY_ENVIRONMENT.PRODUCTION){
			settings_RG_gatewayenv.check(R.id.settings_RB_live);
		} else {
			settings_RG_gatewayenv.check(R.id.settings_RB_uat);
		}

    	if(AppSharedPrefrences.getAppSharedPrefrencesInstace().isPrinterSupportRequired()){
			settings_CHK_printer_support.setChecked(true);
    	}else{
			settings_CHK_printer_support.setChecked(false);
    	}

    	if(AppSharedPrefrences.getAppSharedPrefrencesInstace().isWisepadUSBMode()){
			settings_CHK_usb_mode.setChecked(true);
    	}else{
			settings_CHK_usb_mode.setChecked(false);
    	}


		settings_RG_gatewayenv.setOnCheckedChangeListener((radioGroup, i) -> {

			if (radioGroup.getCheckedRadioButtonId() == R.id.settings_RB_live) {
				AppSharedPrefrences.getAppSharedPrefrencesInstace().setGatewayEnvironment(MSWisepadController.GATEWAY_ENVIRONMENT.PRODUCTION);
			} else if (radioGroup.getCheckedRadioButtonId() == R.id.settings_RB_uat) {
				AppSharedPrefrences.getAppSharedPrefrencesInstace().setGatewayEnvironment(MSWisepadController.GATEWAY_ENVIRONMENT.LABS);
			}

			MSWisepadController.getSharedMSWisepadController(DeviceSettings.this,
					AppSharedPrefrences.getAppSharedPrefrencesInstace().getGatewayEnvironment(),
					AppSharedPrefrences.getAppSharedPrefrencesInstace().getNetworkSource(),
					null).setGatewaySource(AppSharedPrefrences.getAppSharedPrefrencesInstace().getGatewayEnvironment());

		});

		settings_CHK_usb_mode.setOnClickListener(view -> {

			if (settings_CHK_usb_mode.isChecked()) {
				AppSharedPrefrences.getAppSharedPrefrencesInstace().setWisepadUSBMode(true);
			} else {
				AppSharedPrefrences.getAppSharedPrefrencesInstace().setWisepadUSBMode(false);
			}
		});

		settings_CHK_printer_support.setOnClickListener(view -> {

			if (settings_CHK_printer_support.isChecked()) {
				AppSharedPrefrences.getAppSharedPrefrencesInstace().setPrinterSupportRequired(true);
			} else {
				AppSharedPrefrences.getAppSharedPrefrencesInstace().setPrinterSupportRequired(false);
			}
		});
    }
}
