package com.mswipetech.wisepos.demo.sdk.view.settings;

import android.app.Activity;
import android.os.Bundle;

import com.mswipetech.wisepos.demo.sdk.R;
import com.mswipetech.wisepos.demo.sdk.data.ApplicationData;
import com.mswipetech.wisepos.demo.sdk.util.Logs;
import com.mswipetech.wisepos.demo.sdk.util.Utils;

import java.util.ArrayList;

public class PermissionsActivity extends Activity {

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_permissions);
    }

    @Override
    protected void onResume() {
        super.onResume();
        requestPermissions();
    }

    private void requestPermissions() {
//        List<String> listPermissionsNeeded = new ArrayList<>();
//        listPermissionsNeeded.add(RECORD_AUDIO);
//        listPermissionsNeeded.add("android.permission.BBPOS");
//        listPermissionsNeeded.add(READ_PHONE_STATE);
//        listPermissionsNeeded.add(READ_EXTERNAL_STORAGE);
//        listPermissionsNeeded.add(WRITE_EXTERNAL_STORAGE);
//        listPermissionsNeeded.add(ACCESS_COARSE_LOCATION);
//        listPermissionsNeeded.add(VIBRATE);
//        listPermissionsNeeded.add(BLUETOOTH_CONNECT);
//        listPermissionsNeeded.add(BLUETOOTH_SCAN);
//        requestPermissions(listPermissionsNeeded.toArray(new String[listPermissionsNeeded.size()]), 1001);
        ArrayList<String> permList = Utils.getPermissionList();
        String[] permArray = new String[permList.size()];
        permArray = permList.toArray(permArray);
        requestPermissions(permArray, 1001);
    }

    /**
     * Callback received when a permissions request has been completed.
     */
    public void onRequestPermissionsResult(int requestCode, String[] permissions, int[] grantResults) {

        if (ApplicationData.IS_DEBUGGING_ON)
            Logs.v(ApplicationData.packName, "requestCode: " + requestCode, true, true);
        if (ApplicationData.IS_DEBUGGING_ON)
            Logs.v(ApplicationData.packName, "grantResults.length: " + grantResults.length, true, true);

        try {
            for (int i = 0; i < grantResults.length; i++) {
                if (ApplicationData.IS_DEBUGGING_ON)
                    Logs.v(ApplicationData.packName, "grantResults[" + i + "] :" + grantResults[i], true, true);
            }
        } catch (Exception e) {
        }

        permissionsGranted();
    }

    private void permissionsGranted() {
        finish();
    }

}
