package com.mswipetech.wisepos.demo.sdk.view.wiseposfeatures;


import android.content.Context;
import android.content.Intent;
import android.graphics.drawable.GradientDrawable;
import android.graphics.drawable.GradientDrawable.Orientation;
import android.os.Bundle;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.AdapterView;
import android.widget.AdapterView.OnItemClickListener;
import android.widget.BaseAdapter;
import android.widget.ListView;
import android.widget.RelativeLayout;
import android.widget.TextView;

import com.mswipetech.wisepad.sdk.view.MSAARHandlerActivity;
import com.mswipetech.wisepos.demo.sdk.R;
import com.mswipetech.wisepos.demo.sdk.data.ApplicationData;
import com.mswipetech.wisepos.demo.sdk.util.Logs;
import com.mswipetech.wisepos.demo.sdk.view.BaseTitleActivity;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;


/**
 * MenuView
 * MenuView activity lists all the Mswipe api's available, each entry will demonstrate the integration process
 * of the api
 *
 */

public class WiseposMenuActivity extends BaseTitleActivity {

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.view_wisepos);

		initViews();

	}

	private void initViews() {

		ListView listView = (ListView) findViewById(R.id.wisepos_view_LST_options);

		String[] values = new String[]
				{
						"Barcode Reader",
						"Print Demo"/*,
						"AAR Print Demo"*/
				};

		((RelativeLayout) findViewById(R.id.top_bar)).setVisibility(View.GONE);

		TextView txtHeading = (TextView) findViewById(R.id.topbar_LBL_heading);
		txtHeading.setText("SDK List");

		MenuViewAdapter adapter = new MenuViewAdapter(this, values);
		int[] colors = {0, 0xFF0000FF, 0};
		listView.setDivider(new GradientDrawable(Orientation.LEFT_RIGHT, colors));
		listView.setDividerHeight(1);

		listView.setAdapter(adapter);
		listView.setOnItemClickListener(new OnItemClickListener() {

			@Override
			public void onItemClick(AdapterView<?> arg0, View arg1, int arg2, long arg3) {

				int menuoption = 0;

				if (arg2 == 0) {
					Intent intent = new Intent(WiseposMenuActivity.this, BarcodeReaderView.class);
					startActivity(intent);
				}

				if (arg2 == 1) {
					Intent intent = new Intent(WiseposMenuActivity.this, PrinteNeoDemo.class);
					startActivity(intent);
				}

				if (arg2 == 2) {
					processPrint();
				}

			}
		});

	}

	@Override
	public void onBackPressed() {
		// TODO Auto-generated method stub
		super.onBackPressed();

	}

	public class MenuViewAdapter extends BaseAdapter {
		String[] listData = null;
		Context context;

		public MenuViewAdapter(Context context, String[] listData) {
			this.listData = listData;
			this.context = context;
		}

		@Override
		public int getCount() {
			// TODO Auto-generated method stub
			return listData.length;
		}

		@Override
		public Object getItem(int position) {
			// TODO Auto-generated method stub
			return null;
		}

		@Override
		public long getItemId(int position) {
			// TODO Auto-generated method stub
			return 0;
		}

		@Override
		public View getView(int position, View convertView, ViewGroup parent) {
			// TODO Auto-generated method stub
			if (convertView == null) {
				LayoutInflater inflater = LayoutInflater.from(context);
				convertView = inflater.inflate(R.layout.view_menulstitem, null);
			}
			TextView txtItem = (TextView) convertView.findViewById(R.id.menuview_lsttext);
			txtItem.setText(listData[position]);

			return convertView;
		}
	}

	private static final String MS_PRINT_ACTIVITY_INTENT_ACTION = "mswipe.wisepad.sdk.PrintRequest";

	public static final int MS_PRINT_ACTIVITY_REQUEST_CODE = 1006;

	private void processPrint(){

		JSONArray printJSONArray = new JSONArray();

		printJSONArray.put(addPrintTest("MSWIPE", "center", true));
		printJSONArray.put(addPrintTest("------------------------", "center", true));

		printJSONArray.put(addPrintTest("sample left", "left", true));

		printJSONArray.put(addPrintTest("sample right", "right", true));

		printJSONArray.put(addPrintTest("column 1: ", "left", true));
		printJSONArray.put(addPrintTest("data", "right", false));

		printJSONArray.put(addPrintTest("column 2: ", "left", true));
		printJSONArray.put(addPrintTest("data", "right", false));

		printJSONArray.put(addPrintTest("sample right", "right", true));

		printJSONArray.put(addPrintTest("------------------------", "center", true));
		printJSONArray.put(addPrintTest("THANY YOU", "center", true));
		printJSONArray.put(addPrintTest("------------------------", "center", true));
		printJSONArray.put(addPrintTest("VER 1.0.0", "center", true));
		printJSONArray.put(addPrintTest(" ", "center", true));

		if(ApplicationData.IS_DEBUGGING_ON)
			Logs.v(ApplicationData.packName,"printJSONArray: " + printJSONArray.toString(),true,true);

		Intent intent = new Intent(WiseposMenuActivity.this, MSAARHandlerActivity.class);
		intent.setType(MS_PRINT_ACTIVITY_INTENT_ACTION);
		intent.putExtra("printdata", printJSONArray.toString());
		startActivityForResult(intent, MS_PRINT_ACTIVITY_REQUEST_CODE);
	}


	private JSONObject addPrintTest(String printtext, String aline, boolean newLine){

		if(ApplicationData.IS_DEBUGGING_ON)
			Logs.v(ApplicationData.packName,"printtext: " + printtext + " aline: " + aline + " newLine: " + newLine ,true,true);

		JSONObject jsonObject = new JSONObject();

		try {
			jsonObject = new JSONObject();
			jsonObject.put("printtext", printtext);
			jsonObject.put("aline", aline);
			jsonObject.put("newLine", newLine);

			return jsonObject;
		} catch (JSONException e) {
			e.printStackTrace();
		}

		return jsonObject;
	}
}
